"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var assert = __importStar(require("assert"));
var chai = __importStar(require("chai"));
var chaiFiles = __importStar(require("chai-files"));
var fsExtra = __importStar(require("fs-extra"));
var path = __importStar(require("path"));
var JSZip = __importStar(require("jszip"));
var nrc = __importStar(require("node-run-cmd"));
var sinon_1 = require("sinon");
var sinon = sinon_1.createSandbox();
var deferred = __importStar(require("deferred"));
var glob = __importStar(require("glob"));
var RokuDeploy_1 = require("./RokuDeploy");
var errors = __importStar(require("./Errors"));
var util_1 = require("./util");
chai.use(chaiFiles);
var expect = chai.expect;
var file = chaiFiles.file;
var dir = chaiFiles.dir;
var cwd = process.cwd();
var tmpPath = util_1.standardizePath(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", "/.tmp"], ["", "/.tmp"])), cwd);
describe('index', function () {
    var rokuDeploy;
    //make an <any> ref to rokuDeploy to make some things easier
    var rd;
    beforeEach(function () {
        rokuDeploy = new RokuDeploy_1.RokuDeploy();
        rd = rokuDeploy;
    });
    var options;
    var originalCwd = process.cwd();
    beforeEach(function () {
        options = rokuDeploy.getOptions();
        options.rootDir = './testProject';
    });
    afterEach(function () {
        //restore the original working directory
        process.chdir(originalCwd);
        //delete the output file and other interim files
        var filePaths = [
            path.resolve(options.outDir),
            tmpPath
        ];
        for (var _i = 0, filePaths_1 = filePaths; _i < filePaths_1.length; _i++) {
            var filePath = filePaths_1[_i];
            try {
                fsExtra.removeSync(filePath);
            }
            catch (e) { }
        }
        sinon.restore();
    });
    describe('getOutputPkgFilePath', function () {
        it('should return correct path if given basename', function () {
            options.outFile = 'roku-deploy';
            var outputPath = rokuDeploy.getOutputPkgFilePath(options);
            expect(outputPath).to.equal(path.join(path.resolve(options.outDir), options.outFile + '.pkg'));
        });
        it('should return correct path if given outFile option ending in .zip', function () {
            options.outFile = 'roku-deploy.zip';
            var outputPath = rokuDeploy.getOutputPkgFilePath(options);
            expect(outputPath).to.equal(path.join(path.resolve(options.outDir), 'roku-deploy.pkg'));
        });
    });
    describe('getOutputZipFilePath', function () {
        it('should return correct path if given basename', function () {
            options.outFile = 'roku-deploy';
            var outputPath = rokuDeploy.getOutputZipFilePath(options);
            expect(outputPath).to.equal(path.join(path.resolve(options.outDir), options.outFile + '.zip'));
        });
        it('should return correct path if given outFile option ending in .zip', function () {
            options.outFile = 'roku-deploy.zip';
            var outputPath = rokuDeploy.getOutputZipFilePath(options);
            expect(outputPath).to.equal(path.join(path.resolve(options.outDir), 'roku-deploy.zip'));
        });
    });
    describe('doPostRequest', function () {
        it('should not throw an error for a successful request', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = 'responseBody';
                        sinon.stub(rokuDeploy.request, 'post').callsFake(function (_, callback) {
                            process.nextTick(callback, undefined, { statusCode: 200 }, body);
                            return {};
                        });
                        return [4 /*yield*/, rokuDeploy.doPostRequest({}, true)];
                    case 1:
                        results = _a.sent();
                        expect(results.body).to.equal(body);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw an error for a network error', function () { return __awaiter(void 0, void 0, void 0, function () {
            var error, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        error = new Error('Network Error');
                        sinon.stub(rokuDeploy.request, 'post').callsFake(function (_, callback) {
                            process.nextTick(callback, error);
                            return {};
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.doPostRequest({}, true)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        expect(e_1).to.equal(error);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw an error for a wrong response code if verify is true', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = 'responseBody';
                        sinon.stub(rokuDeploy.request, 'post').callsFake(function (_, callback) {
                            process.nextTick(callback, undefined, { statusCode: 500 }, body);
                            return {};
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.doPostRequest({}, true)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        expect(e_2).to.be.instanceof(errors.InvalidDeviceResponseCodeError);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should not throw an error for a response code if verify is false', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = 'responseBody';
                        sinon.stub(rokuDeploy.request, 'post').callsFake(function (_, callback) {
                            process.nextTick(callback, undefined, { statusCode: 500 }, body);
                            return {};
                        });
                        return [4 /*yield*/, rokuDeploy.doPostRequest({}, false)];
                    case 1:
                        results = _a.sent();
                        expect(results.body).to.equal(body);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('doGetRequest', function () {
        it('should not throw an error for a successful request', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = 'responseBody';
                        sinon.stub(rokuDeploy.request, 'get').callsFake(function (_, callback) {
                            process.nextTick(callback, undefined, { statusCode: 200 }, body);
                            return {};
                        });
                        return [4 /*yield*/, rokuDeploy.doGetRequest({})];
                    case 1:
                        results = _a.sent();
                        expect(results.body).to.equal(body);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw an error for a network error', function () { return __awaiter(void 0, void 0, void 0, function () {
            var error, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        error = new Error('Network Error');
                        sinon.stub(rokuDeploy.request, 'get').callsFake(function (_, callback) {
                            process.nextTick(callback, error);
                            return {};
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.doGetRequest({})];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _a.sent();
                        expect(e_3).to.equal(error);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getRokuMessagesFromResponseBody', function () {
        it('exits on unknown message type', function () {
            var result = rokuDeploy['getRokuMessagesFromResponseBody']("\n                Shell.create('Roku.Message').trigger('Set message type', 'unknown').trigger('Set message content', 'Failure: Form Error: \"archive\" Field Not Found').trigger('Render', node);\n            ");
            expect(result).to.eql({
                errors: [],
                infos: [],
                successes: []
            });
        });
        it('pull errors from the response body', function () {
            var body = getFakeResponseBody("\n                Shell.create('Roku.Message').trigger('Set message type', 'error').trigger('Set message content', 'Failure: Form Error: \"archive\" Field Not Found').trigger('Render', node);\n            ");
            var results = rokuDeploy['getRokuMessagesFromResponseBody'](body);
            expect(results).to.eql({
                errors: ['Failure: Form Error: "archive" Field Not Found'],
                infos: [],
                successes: []
            });
        });
        it('pull successes from the response body', function () {
            var body = getFakeResponseBody("\n            Shell.create('Roku.Message').trigger('Set message type', 'success').trigger('Set message content', 'Screenshot ok').trigger('Render', node);\n            ");
            var results = rokuDeploy['getRokuMessagesFromResponseBody'](body);
            expect(results).to.eql({
                errors: [],
                infos: [],
                successes: ['Screenshot ok']
            });
        });
        it('pull many messages from the response body', function () {
            var body = getFakeResponseBody("\n            Shell.create('Roku.Message').trigger('Set message type', 'success').trigger('Set message content', 'Screenshot ok').trigger('Render', node);\n            Shell.create('Roku.Message').trigger('Set message type', 'info').trigger('Set message content', 'Some random info message').trigger('Render', node);\n            Shell.create('Roku.Message').trigger('Set message type', 'error').trigger('Set message content', 'Failure: Form Error: \"archive\" Field Not Found').trigger('Render', node);\n            Shell.create('Roku.Message').trigger('Set message type', 'error').trigger('Set message content', 'Failure: Form Error: \"archive\" Field Not Found').trigger('Render', node);\n            ");
            var results = rokuDeploy['getRokuMessagesFromResponseBody'](body);
            expect(results).to.eql({
                errors: ['Failure: Form Error: "archive" Field Not Found', 'Failure: Form Error: "archive" Field Not Found'],
                infos: ['Some random info message'],
                successes: ['Screenshot ok']
            });
        });
    });
    describe('getDeviceInfo', function () {
        it('should return device info matching what was returned by ECP', function () { return __awaiter(void 0, void 0, void 0, function () {
            var expectedSerialNumber, expectedDeviceId, expectedDeveloperId, body, deviceInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expectedSerialNumber = 'expectedSerialNumber';
                        expectedDeviceId = 'expectedDeviceId';
                        expectedDeveloperId = 'expectedDeveloperId';
                        body = "<device-info>\n                <udn>29380007-0800-1025-80a4-d83154332d7e</udn>\n                <serial-number>" + expectedSerialNumber + "</serial-number>\n                <device-id>" + expectedDeviceId + "</device-id>\n                <advertising-id>2cv488ca-d6ec-5222-9304-1925e72d0122</advertising-id>\n                <vendor-name>Roku</vendor-name>\n                <model-name>Roku Ultra</model-name>\n                <model-number>4660X</model-number>\n                <model-region>US</model-region>\n                <is-tv>false</is-tv>\n                <is-stick>false</is-stick>\n                <supports-ethernet>true</supports-ethernet>\n                <wifi-mac>d8:31:34:33:6d:6e</wifi-mac>\n                <wifi-driver>realtek</wifi-driver>\n                <has-wifi-extender>false</has-wifi-extender>\n                <has-wifi-5G-support>true</has-wifi-5G-support>\n                <can-use-wifi-extender>true</can-use-wifi-extender>\n                <ethernet-mac>e8:31:34:36:2d:2e</ethernet-mac>\n                <network-type>ethernet</network-type>\n                <friendly-device-name>Brian's Roku Ultra</friendly-device-name>\n                <friendly-model-name>Roku Ultra</friendly-model-name>\n                <default-device-name>Roku Ultra - YB0072009656</default-device-name>\n                <user-device-name>Brian's Roku Ultra</user-device-name>\n                <user-device-location>Hot Tub</user-device-location>\n                <build-number>469.30E04170A</build-number>\n                <software-version>9.3.0</software-version>\n                <software-build>4170</software-build>\n                <secure-device>true</secure-device>\n                <language>en</language>\n                <country>US</country>\n                <locale>en_US</locale>\n                <time-zone-auto>true</time-zone-auto>\n                <time-zone>US/Eastern</time-zone>\n                <time-zone-name>United States/Eastern</time-zone-name>\n                <time-zone-tz>America/New_York</time-zone-tz>\n                <time-zone-offset>-240</time-zone-offset>\n                <clock-format>12-hour</clock-format>\n                <uptime>19799</uptime>\n                <power-mode>PowerOn</power-mode>\n                <supports-suspend>false</supports-suspend>\n                <supports-find-remote>true</supports-find-remote>\n                <find-remote-is-possible>true</find-remote-is-possible>\n                <supports-audio-guide>true</supports-audio-guide>\n                <supports-rva>true</supports-rva>\n                <developer-enabled>true</developer-enabled>\n                <keyed-developer-id>" + expectedDeveloperId + "</keyed-developer-id>\n                <search-enabled>true</search-enabled>\n                <search-channels-enabled>true</search-channels-enabled>\n                <voice-search-enabled>true</voice-search-enabled>\n                <notifications-enabled>true</notifications-enabled>\n                <notifications-first-use>false</notifications-first-use>\n                <supports-private-listening>true</supports-private-listening>\n                <headphones-connected>false</headphones-connected>\n                <supports-ecs-textedit>true</supports-ecs-textedit>\n                <supports-ecs-microphone>true</supports-ecs-microphone>\n                <supports-wake-on-wlan>false</supports-wake-on-wlan>\n                <has-play-on-roku>true</has-play-on-roku>\n                <has-mobile-screensaver>true</has-mobile-screensaver>\n                <support-url>roku.com/support</support-url>\n                <grandcentral-version>3.1.39</grandcentral-version>\n                <trc-version>3.0</trc-version>\n                <trc-channel-version>2.9.42</trc-channel-version>\n                <davinci-version>2.8.20</davinci-version>\n            </device-info>";
                        mockDoGetRequest(body);
                        return [4 /*yield*/, rokuDeploy.getDeviceInfo(options)];
                    case 1:
                        deviceInfo = _a.sent();
                        expect(deviceInfo['serial-number']).to.equal(expectedSerialNumber);
                        expect(deviceInfo['device-id']).to.equal(expectedDeviceId);
                        expect(deviceInfo['keyed-developer-id']).to.equal(expectedDeveloperId);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw our error on failure', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mockDoGetRequest();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.getDeviceInfo(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_4 = _a.sent();
                        expect(e_4).to.be.instanceof(errors.UnparsableDeviceResponseError);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getDevId', function () {
        it('should return the current Dev ID if successful', function () { return __awaiter(void 0, void 0, void 0, function () {
            var expectedDevId, body, devId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expectedDevId = 'expectedDevId';
                        body = "<device-info>\n                <keyed-developer-id>" + expectedDevId + "</keyed-developer-id>\n            </device-info>";
                        mockDoGetRequest(body);
                        options.devId = expectedDevId;
                        return [4 /*yield*/, rokuDeploy.getDevId(options)];
                    case 1:
                        devId = _a.sent();
                        expect(devId).to.equal(expectedDevId);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('copyToStaging', function () {
        it('throws exceptions when rootDir does not exist', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, expectThrowsAsync(function () { return rokuDeploy.copyToStaging([], 'staging', 'folder_does_not_exist'); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('throws exceptions on missing stagingPath', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, expectThrowsAsync(function () { return rokuDeploy.copyToStaging([]); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('throws exceptions on missing rootDir', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, expectThrowsAsync(function () { return rokuDeploy.copyToStaging([], 'asdf'); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('computes absolute path for all operations', function () { return __awaiter(void 0, void 0, void 0, function () {
            var ensureDirPaths, copyPaths, rootDir, stagingPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ensureDirPaths = [];
                        sinon.stub(rokuDeploy.fsExtra, 'ensureDir').callsFake(function (p) {
                            ensureDirPaths.push(p);
                            return Promise.resolve;
                        });
                        copyPaths = [];
                        sinon.stub(rokuDeploy.fsExtra, 'copy').callsFake(function (src, dest) {
                            copyPaths.push({ src: src, dest: dest });
                            return Promise.resolve();
                        });
                        rootDir = util_1.standardizePath(templateObject_2 || (templateObject_2 = __makeTemplateObject(["", "/ProjectA/src"], ["", "/ProjectA/src"])), tmpPath);
                        fsExtra.ensureDirSync(rootDir);
                        stagingPath = util_1.standardizePath(templateObject_3 || (templateObject_3 = __makeTemplateObject(["", "/ProjectA/.staging"], ["", "/ProjectA/.staging"])), tmpPath);
                        sinon.stub(rokuDeploy, 'getFilePaths').returns(Promise.resolve([
                            {
                                src: util_1.standardizePath(templateObject_4 || (templateObject_4 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                dest: '/source/main.brs'
                            }, {
                                src: util_1.standardizePath(templateObject_5 || (templateObject_5 = __makeTemplateObject(["", "/components/a/b/c/comp1.xml"], ["", "/components/a/b/c/comp1.xml"])), rootDir),
                                dest: '/components/a/b/c/comp1.xml'
                            }
                        ]));
                        return [4 /*yield*/, rokuDeploy.copyToStaging([], stagingPath, rootDir)];
                    case 1:
                        _a.sent();
                        expect(ensureDirPaths).to.eql([
                            util_1.standardizePath(templateObject_6 || (templateObject_6 = __makeTemplateObject(["", "/source"], ["", "/source"])), stagingPath),
                            util_1.standardizePath(templateObject_7 || (templateObject_7 = __makeTemplateObject(["", "/components/a/b/c"], ["", "/components/a/b/c"])), stagingPath)
                        ]);
                        expect(copyPaths).to.eql([
                            {
                                src: util_1.standardizePath(templateObject_8 || (templateObject_8 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                dest: util_1.standardizePath(templateObject_9 || (templateObject_9 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), stagingPath)
                            }, {
                                src: util_1.standardizePath(templateObject_10 || (templateObject_10 = __makeTemplateObject(["", "/components/a/b/c/comp1.xml"], ["", "/components/a/b/c/comp1.xml"])), rootDir),
                                dest: util_1.standardizePath(templateObject_11 || (templateObject_11 = __makeTemplateObject(["", "/components/a/b/c/comp1.xml"], ["", "/components/a/b/c/comp1.xml"])), stagingPath)
                            }
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('zipPackage', function () {
        it('should throw error when manifest is missing', function () { return __awaiter(void 0, void 0, void 0, function () {
            var err, e_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        options.stagingFolderPath = util_1.standardizePath(templateObject_12 || (templateObject_12 = __makeTemplateObject(["", "/path/to/nowhere"], ["", "/path/to/nowhere"])), tmpPath);
                        fsExtra.ensureDirSync(options.stagingFolderPath);
                        return [4 /*yield*/, rokuDeploy.zipPackage(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_5 = _a.sent();
                        err = e_5;
                        return [3 /*break*/, 3];
                    case 3:
                        expect(err).to.exist;
                        expect(err.message.startsWith('Cannot zip'), "Unexpected error message: \"" + err.message + "\"").to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw error when manifest is missing and stagingDir does not exist', function () { return __awaiter(void 0, void 0, void 0, function () {
            var err, e_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        options.stagingFolderPath = util_1.standardizePath(templateObject_13 || (templateObject_13 = __makeTemplateObject(["", "/path/to/nowhere"], ["", "/path/to/nowhere"])), tmpPath);
                        return [4 /*yield*/, rokuDeploy.zipPackage(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_6 = _a.sent();
                        err = e_6;
                        return [3 /*break*/, 3];
                    case 3:
                        expect(err).to.exist;
                        expect(err.message.startsWith('Cannot zip'), "Unexpected error message: \"" + err.message + "\"").to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('createPackage', function () {
        it('works with custom stagingFolderPath', function () { return __awaiter(void 0, void 0, void 0, function () {
            var opts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        opts = __assign(__assign({}, options), { files: [
                                'manifest'
                            ], stagingFolderPath: '.tmp/dist' });
                        return [4 /*yield*/, rokuDeploy.createPackage(opts)];
                    case 1:
                        _a.sent();
                        expect(file(rokuDeploy.getOutputZipFilePath(opts))).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw error when no files were found to copy', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, assertThrowsAsync(function () { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        options.files = [];
                                        return [4 /*yield*/, rokuDeploy.createPackage(options)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should create package in proper directory', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, rokuDeploy.createPackage(__assign(__assign({}, options), { files: [
                                'manifest'
                            ] }))];
                    case 1:
                        _a.sent();
                        expect(file(rokuDeploy.getOutputZipFilePath(options))).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should only include the specified files', function () { return __awaiter(void 0, void 0, void 0, function () {
            var files, data, zip, _i, files_1, file_1, zipFileContents, sourcePath, incomingContents;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        files = ['manifest'];
                        options.files = files;
                        return [4 /*yield*/, rokuDeploy.createPackage(options)];
                    case 1:
                        _a.sent();
                        data = fsExtra.readFileSync(rokuDeploy.getOutputZipFilePath(options));
                        return [4 /*yield*/, JSZip.loadAsync(data)];
                    case 2:
                        zip = _a.sent();
                        _i = 0, files_1 = files;
                        _a.label = 3;
                    case 3:
                        if (!(_i < files_1.length)) return [3 /*break*/, 6];
                        file_1 = files_1[_i];
                        return [4 /*yield*/, zip.file(file_1.toString()).async('string')];
                    case 4:
                        zipFileContents = _a.sent();
                        sourcePath = path.join(options.rootDir, file_1);
                        incomingContents = fsExtra.readFileSync(sourcePath, 'utf8');
                        expect(zipFileContents).to.equal(incomingContents);
                        _a.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/];
                }
            });
        }); });
        it('generates full package with defaults', function () { return __awaiter(void 0, void 0, void 0, function () {
            var files, data, zip, _i, files_2, file_2, zipFileContents, sourcePath, incomingContents;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        files = [
                            'components/components/Loader/Loader.brs',
                            'images/splash_hd.jpg',
                            'source/main.brs',
                            'manifest'
                        ];
                        return [4 /*yield*/, rokuDeploy.createPackage(__assign(__assign({}, options), { 
                                //target a subset of the files to make the test faster
                                files: files }))];
                    case 1:
                        _a.sent();
                        data = fsExtra.readFileSync(rokuDeploy.getOutputZipFilePath(options));
                        return [4 /*yield*/, JSZip.loadAsync(data)];
                    case 2:
                        zip = _a.sent();
                        _i = 0, files_2 = files;
                        _a.label = 3;
                    case 3:
                        if (!(_i < files_2.length)) return [3 /*break*/, 6];
                        file_2 = files_2[_i];
                        return [4 /*yield*/, zip.file(file_2.toString()).async('string')];
                    case 4:
                        zipFileContents = _a.sent();
                        sourcePath = path.join(options.rootDir, file_2);
                        incomingContents = fsExtra.readFileSync(sourcePath, 'utf8');
                        expect(zipFileContents).to.equal(incomingContents);
                        _a.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/];
                }
            });
        }); });
        it('should retain the staging directory when told to', function () { return __awaiter(void 0, void 0, void 0, function () {
            var stagingFolderPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, rokuDeploy.prepublishToStaging(__assign(__assign({}, options), { files: [
                                'manifest'
                            ] }))];
                    case 1:
                        stagingFolderPath = _a.sent();
                        expect(dir(stagingFolderPath)).to.exist;
                        options.retainStagingFolder = true;
                        return [4 /*yield*/, rokuDeploy.zipPackage(options)];
                    case 2:
                        _a.sent();
                        expect(dir(stagingFolderPath)).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should call our callback with correct information', function () { return __awaiter(void 0, void 0, void 0, function () {
            var spy;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        spy = sinon.spy(function (info) {
                            expect(dir(info.stagingFolderPath)).to.exist;
                            expect(info.manifestData.major_version).to.equal('1');
                        });
                        return [4 /*yield*/, rokuDeploy.createPackage(options, spy)];
                    case 1:
                        _a.sent();
                        if (spy.notCalled) {
                            assert.fail('Callback not called');
                        }
                        return [2 /*return*/];
                }
            });
        }); });
        it('should wait for promise returned by pre-zip callback', function () { return __awaiter(void 0, void 0, void 0, function () {
            var count;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        count = 0;
                        return [4 /*yield*/, rokuDeploy.createPackage(__assign(__assign({}, options), { files: ['manifest'] }), function (info) {
                                return Promise.resolve().then(function () {
                                    count++;
                                }).then(function () {
                                    count++;
                                });
                            })];
                    case 1:
                        _a.sent();
                        expect(count).to.equal(2);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should increment the build number if requested', function () { return __awaiter(void 0, void 0, void 0, function () {
            var beforeZipInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.incrementBuildNumber = true;
                        //make the zipping immediately resolve
                        sinon.stub(rokuDeploy, 'zipPackage').returns(Promise.resolve());
                        return [4 /*yield*/, rokuDeploy.createPackage(__assign(__assign({}, options), { files: ['manifest'] }), function (info) {
                                beforeZipInfo = info;
                            })];
                    case 1:
                        _a.sent();
                        expect(beforeZipInfo.manifestData.build_version).to.not.equal('0');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should not increment the build number if not requested', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.incrementBuildNumber = false;
                        return [4 /*yield*/, rokuDeploy.createPackage(__assign(__assign({}, options), { files: [
                                    'manifest'
                                ] }), function (info) {
                                expect(info.manifestData.build_version).to.equal('0');
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    it('runs via the command line using the rokudeploy.json file', function test(done) {
        this.timeout(20000);
        nrc.run('node dist/index.js', {
            onData: function (data) {
            }
        }).then(function () {
            assert.ok('deploy succeeded');
            done();
        }, function () {
            assert.fail('deploy failed');
            done();
        });
    });
    describe('generateBaseRequestOptions', function () {
        it('uses default port', function () {
            expect(rokuDeploy.generateBaseRequestOptions('a_b_c', { host: '1.2.3.4' }).url).to.equal('http://1.2.3.4:80/a_b_c');
        });
        it('uses overridden port', function () {
            expect(rokuDeploy.generateBaseRequestOptions('a_b_c', { host: '1.2.3.4', packagePort: 999 }).url).to.equal('http://1.2.3.4:999/a_b_c');
        });
    });
    describe('pressHomeButton', function () {
        it('rejects promise on error', function () {
            //intercept the post requests
            sinon.stub(rokuDeploy.request, 'post').callsFake(function (_, callback) {
                process.nextTick(callback, new Error());
                return {};
            });
            return rokuDeploy.pressHomeButton({}).then(function () {
                assert.fail('Should have rejected the promise');
            }, function () {
                expect(true).to.be.true;
            });
        });
        it('uses default port', function () { return __awaiter(void 0, void 0, void 0, function () {
            var d;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        d = deferred();
                        sinon.stub(rokuDeploy, 'doPostRequest').callsFake(function (opts) {
                            expect(opts.url).to.equal('http://1.2.3.4:8060/keypress/Home');
                            d.resolve();
                        });
                        return [4 /*yield*/, rokuDeploy.pressHomeButton('1.2.3.4')];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, d.promise];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('uses overridden port', function () { return __awaiter(void 0, void 0, void 0, function () {
            var d;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        d = deferred();
                        sinon.stub(rokuDeploy, 'doPostRequest').callsFake(function (opts) {
                            expect(opts.url).to.equal('http://1.2.3.4:987/keypress/Home');
                            d.resolve();
                        });
                        return [4 /*yield*/, rokuDeploy.pressHomeButton('1.2.3.4', 987)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, d.promise];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('uses default timeout', function () { return __awaiter(void 0, void 0, void 0, function () {
            var d;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        d = deferred();
                        sinon.stub(rokuDeploy, 'doPostRequest').callsFake(function (opts) {
                            expect(opts.url).to.equal('http://1.2.3.4:8060/keypress/Home');
                            expect(opts.timeout).to.equal(150000);
                            d.resolve();
                        });
                        return [4 /*yield*/, rokuDeploy.pressHomeButton('1.2.3.4')];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, d.promise];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('uses overridden timeout', function () { return __awaiter(void 0, void 0, void 0, function () {
            var d;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        d = deferred();
                        sinon.stub(rokuDeploy, 'doPostRequest').callsFake(function (opts) {
                            expect(opts.url).to.equal('http://1.2.3.4:987/keypress/Home');
                            expect(opts.timeout).to.equal(1000);
                            d.resolve();
                        });
                        return [4 /*yield*/, rokuDeploy.pressHomeButton('1.2.3.4', 987, 1000)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, d.promise];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    var fileCounter = 1;
    describe('publish', function () {
        beforeEach(function () {
            options.host = '0.0.0.0';
            //rename the rokudeploy.json file so publish doesn't pick it up
            try {
                fsExtra.renameSync('rokudeploy.json', 'temp.rokudeploy.json');
            }
            catch (e) { }
            //make a dummy output file...we don't care what's in it
            options.outFile = "temp" + fileCounter++ + ".zip";
            try {
                fsExtra.mkdirSync(options.outDir);
            }
            catch (e) { }
            try {
                fsExtra.appendFileSync(options.outDir + "/" + options.outFile, 'asdf');
            }
            catch (e) { }
        });
        afterEach(function () {
            //rename the rokudeploy.json file so publish doesn't pick it up
            try {
                fsExtra.renameSync('temp.rokudeploy.json', 'rokudeploy.json');
            }
            catch (e) { }
        });
        it('does not delete the archive by default', function () { return __awaiter(void 0, void 0, void 0, function () {
            var zipPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        zipPath = options.outDir + "/" + options.outFile;
                        mockDoPostRequest();
                        //the file should exist
                        expect(fsExtra.pathExistsSync(zipPath)).to.be.true;
                        return [4 /*yield*/, rokuDeploy.publish(options)];
                    case 1:
                        _a.sent();
                        //the file should still exist
                        expect(fsExtra.pathExistsSync(zipPath)).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        it('deletes the archive when configured', function () { return __awaiter(void 0, void 0, void 0, function () {
            var zipPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        zipPath = options.outDir + "/" + options.outFile;
                        mockDoPostRequest();
                        //the file should exist
                        expect(fsExtra.pathExistsSync(zipPath)).to.be.true;
                        return [4 /*yield*/, rokuDeploy.publish(__assign(__assign({}, options), { retainDeploymentArchive: false }))];
                    case 1:
                        _a.sent();
                        //the file should not exist
                        expect(fsExtra.pathExistsSync(zipPath)).to.be.false;
                        return [2 /*return*/];
                }
            });
        }); });
        it('fails when the zip file is missing', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_7, zipFilePath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.outFile = 'fileThatDoesNotExist.zip';
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.publish(options)];
                    case 2:
                        _a.sent();
                        throw new Error('publish should have thrown an exception');
                    case 3:
                        e_7 = _a.sent();
                        zipFilePath = rokuDeploy.getOutputZipFilePath(options);
                        expect(e_7.message).to.equal("Cannot publish because file does not exist at '" + zipFilePath + "'");
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('fails when no host is provided', function () {
            expect(file('rokudeploy.json')).not.to.exist;
            return rokuDeploy.publish({ host: undefined }).then(function () {
                assert.fail('Should not have succeeded');
            }, function () {
                expect(true).to.be.true;
            });
        });
        it('throws when package upload fails', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        //intercept the post requests
                        sinon.stub(rokuDeploy.request, 'post').callsFake(function (data, callback) {
                            if (data.url === "http://" + options.host + "/plugin_install") {
                                process.nextTick(function () {
                                    callback(new Error('Failed to publish to server'));
                                });
                            }
                            else {
                                process.nextTick(callback);
                            }
                            return {};
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.publish(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_8 = _a.sent();
                        assert.ok('Exception was thrown as expected');
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Should not have succeeded');
                        return [2 /*return*/];
                }
            });
        }); });
        it('rejects when response contains compile error wording', function () {
            options.failOnCompileError = true;
            var body = 'Install Failure: Compilation Failed.';
            mockDoPostRequest(body);
            return rokuDeploy.publish(options).then(function () {
                assert.fail('Should not have succeeded due to roku server compilation failure');
            }, function (err) {
                expect(err.message).to.equal('Compile error');
                expect(true).to.be.true;
            });
        });
        it('rejects when response contains invalid password status code', function () {
            options.failOnCompileError = true;
            mockDoPostRequest('', 401);
            return rokuDeploy.publish(options).then(function () {
                assert.fail('Should not have succeeded due to roku server compilation failure');
            }, function (err) {
                expect(err.message).to.equal('Unauthorized. Please verify username and password for target Roku.');
                expect(true).to.be.true;
            });
        });
        it('handles successful deploy', function () {
            options.failOnCompileError = true;
            mockDoPostRequest();
            return rokuDeploy.publish(options).then(function (result) {
                expect(result.message).to.equal('Successful deploy');
            }, function () {
                assert.fail('Should not have rejected the promise');
            });
        });
        it('handles successful deploy with remoteDebug', function () {
            options.failOnCompileError = true;
            options.remoteDebug = true;
            mockDoPostRequest();
            return rokuDeploy.publish(options).then(function (result) {
                expect(result.message).to.equal('Successful deploy');
            }, function () {
                assert.fail('Should not have rejected the promise');
            });
        });
        it('Does not reject when response contains compile error wording but config is set to ignore compile warnings', function () {
            options.failOnCompileError = false;
            var body = 'Identical to previous version -- not replacing.';
            mockDoPostRequest(body);
            return rokuDeploy.publish(options).then(function (result) {
                expect(result.results.body).to.equal(body);
            }, function () {
                assert.fail('Should have resolved promise');
            });
        });
        it('rejects when response is unknown status code', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, e_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.failOnCompileError = true;
                        body = 'Identical to previous version -- not replacing.';
                        mockDoPostRequest(body, 123);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.publish(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_9 = _a.sent();
                        expect(e_9).to.be.instanceof(errors.InvalidDeviceResponseCodeError);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Should not have succeeded');
                        return [2 /*return*/];
                }
            });
        }); });
        it('rejects when user is unauthorized', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.failOnCompileError = true;
                        mockDoPostRequest('', 401);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.publish(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_10 = _a.sent();
                        expect(e_10).to.be.instanceof(errors.UnauthorizedDeviceResponseError);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Should not have succeeded');
                        return [2 /*return*/];
                }
            });
        }); });
        it('rejects when encountering an undefined response', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.failOnCompileError = true;
                        mockDoPostRequest(null);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.publish(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_11 = _a.sent();
                        assert.ok('Exception was thrown as expected');
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Should not have succeeded');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('convertToSquashfs', function () {
        it('should not return an error if successful', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_12;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mockDoPostRequest('<font color="red">Conversion succeeded<p></p><code><br>Parallel mksquashfs: Using 1 processor');
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.convertToSquashfs(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_12 = _a.sent();
                        assert.fail('Should not have been hit');
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('should return MissingRequiredOptionError if host was not provided', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_13;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mockDoPostRequest();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        options.host = undefined;
                        return [4 /*yield*/, rokuDeploy.convertToSquashfs(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_13 = _a.sent();
                        expect(e_13).to.be.instanceof(errors.MissingRequiredOptionError);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Should not have succeeded');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return ConvertError if converting failed', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_14;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mockDoPostRequest();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.convertToSquashfs(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_14 = _a.sent();
                        expect(e_14).to.be.instanceof(errors.ConvertError);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Should not have succeeded');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('rekeyDevice', function () {
        beforeEach(function () {
            var body = "<device-info>\n                <keyed-developer-id>" + options.devId + "</keyed-developer-id>\n            </device-info>";
            mockDoGetRequest(body);
        });
        it('should work with relative path', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = "  <div style=\"display:none\">\n                <font color=\"red\">Success.</font>\n            </div>";
                        mockDoPostRequest(body);
                        options.rekeySignedPackage = '../testSignedPackage.pkg';
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should work with absolute path', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = "  <div style=\"display:none\">\n                <font color=\"red\">Success.</font>\n            </div>";
                        mockDoPostRequest(body);
                        options.rekeySignedPackage = path.join(path.resolve(options.rootDir, '../testSignedPackage.pkg'));
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should not return an error if dev ID is set and matches output', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = "  <div style=\"display:none\">\n                <font color=\"red\">Success.</font>\n            </div>";
                        mockDoPostRequest(body);
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should not return an error if dev ID is not set', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = "  <div style=\"display:none\">\n                <font color=\"red\">Success.</font>\n            </div>";
                        mockDoPostRequest(body);
                        options.devId = undefined;
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw error if missing rekeySignedPackage option', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_15;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        options.rekeySignedPackage = null;
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_15 = _a.sent();
                        expect(e_15).to.be.instanceof(errors.MissingRequiredOptionError);
                        return [2 /*return*/];
                    case 3:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw error if missing signingPassword option', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_16;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        options.signingPassword = null;
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_16 = _a.sent();
                        expect(e_16).to.be.instanceof(errors.MissingRequiredOptionError);
                        return [2 /*return*/];
                    case 3:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw error if response is not parsable', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_17;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        mockDoPostRequest();
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_17 = _a.sent();
                        expect(e_17).to.be.instanceof(errors.UnparsableDeviceResponseError);
                        return [2 /*return*/];
                    case 3:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw error if we could not verify a successful call', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, e_18;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        body = "  <div style=\"display:none\">\n                    <font color=\"red\">Invalid public key.</font>\n                </div>";
                        mockDoPostRequest(body);
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_18 = _a.sent();
                        expect(e_18).to.be.instanceof(errors.FailedDeviceResponseError);
                        return [2 /*return*/];
                    case 3:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw error if resulting Dev ID is not the one we are expecting', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, e_19;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        body = "  <div style=\"display:none\">\n                    <font color=\"red\">Success.</font>\n                </div>";
                        mockDoPostRequest(body);
                        options.devId = '45fdc2019903ac333ff624b0b2cddd2c733c3e74';
                        return [4 /*yield*/, rokuDeploy.rekeyDevice(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_19 = _a.sent();
                        expect(e_19).to.be.instanceof(errors.UnknownDeviceResponseError);
                        return [2 /*return*/];
                    case 3:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('signExistingPackage', function () {
        beforeEach(function () {
            var stagingFolderPath = rokuDeploy.getOptions().stagingFolderPath;
            fsExtra.ensureDirSync(stagingFolderPath);
            var src = path.join(options.rootDir, 'manifest');
            var dest = path.join(stagingFolderPath, 'manifest');
            fsExtra.copySync(src, dest);
        });
        it('should return our error if signingPassword is not supplied', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_20;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.signingPassword = undefined;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.signExistingPackage(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_20 = _a.sent();
                        expect(e_20.message).to.equal('Must supply signingPassword');
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return an error if there is a problem with the network request', function () { return __awaiter(void 0, void 0, void 0, function () {
            var error, e_21;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        error = new Error('Network Error');
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        //intercept the post requests
                        sinon.stub(rokuDeploy.request, 'post').callsFake(function (_, callback) {
                            process.nextTick(callback, error);
                            return {};
                        });
                        return [4 /*yield*/, rokuDeploy.signExistingPackage(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_21 = _a.sent();
                        expect(e_21).to.equal(error);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return our error if it received invalid data', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_22;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        mockDoPostRequest(null);
                        return [4 /*yield*/, rokuDeploy.signExistingPackage(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_22 = _a.sent();
                        expect(e_22).to.be.instanceof(errors.UnparsableDeviceResponseError);
                        return [2 /*return*/];
                    case 3:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return an error if failure returned in response', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, e_23;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = "<div style=\"display:none\">\n                            <font color=\"red\">Failed: Invalid Password.\n                        </font>\n                        </div>";
                        mockDoPostRequest(body);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.signExistingPackage(options)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_23 = _a.sent();
                        expect(e_23.message).to.equal('Invalid Password.');
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return created pkg on success', function () { return __awaiter(void 0, void 0, void 0, function () {
            var body, pkgPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        body = "var pkgDiv = document.createElement('div');\n                        pkgDiv.innerHTML = '<label>Currently Packaged Application:</label><div><font face=\"Courier\"><a href=\"pkgs//P6953175d5df120c0069c53de12515b9a.pkg\">P6953175d5df120c0069c53de12515b9a.pkg</a> <br> package file (7360 bytes)</font></div>';\n                        node.appendChild(pkgDiv);";
                        mockDoPostRequest(body);
                        return [4 /*yield*/, rokuDeploy.signExistingPackage(options)];
                    case 1:
                        pkgPath = _a.sent();
                        expect(pkgPath).to.equal('pkgs//P6953175d5df120c0069c53de12515b9a.pkg');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return our fallback error if neither error or package link was detected', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_24;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        mockDoPostRequest();
                        return [4 /*yield*/, rokuDeploy.signExistingPackage(options)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_24 = _a.sent();
                        expect(e_24.message).to.equal('Unknown error signing package');
                        return [2 /*return*/];
                    case 3:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('prepublishToStaging', function () {
        it('should use outDir for staging folder', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, rokuDeploy.prepublishToStaging({
                            files: [
                                'manifest'
                            ]
                        })];
                    case 1:
                        _a.sent();
                        expect(dir('out/.roku-deploy-staging')).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('should support overriding the staging folder', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, rokuDeploy.prepublishToStaging(__assign(__assign({}, options), { files: ['manifest'], stagingFolderPath: '.tmp/custom-out-dir' }))];
                    case 1:
                        _a.sent();
                        expect(dir('.tmp/custom-out-dir')).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('handles old glob-style', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.files = [
                            'manifest',
                            'source/main.brs'
                        ];
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/manifest')).to.exist;
                        expect(file('out/.roku-deploy-staging/source/main.brs')).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('handles copying a simple directory by name using src;dest;', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.files = [
                            'manifest',
                            {
                                src: 'source/**/*',
                                dest: 'source'
                            }
                        ];
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/source/main.brs')).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('handles new src;dest style', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.files = [
                            {
                                src: 'manifest',
                                dest: ''
                            },
                            {
                                src: 'source/**/*',
                                dest: 'source/'
                            },
                            {
                                src: 'source/main.brs',
                                dest: 'source/main.brs'
                            }
                        ];
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/manifest')).to.exist;
                        expect(file('out/.roku-deploy-staging/source/main.brs')).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('handles renaming files', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.files = [
                            {
                                src: 'manifest',
                                dest: ''
                            },
                            {
                                src: 'source/main.brs',
                                dest: 'source/renamed.brs'
                            }
                        ];
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/source/renamed.brs')).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('handles absolute src paths', function () { return __awaiter(void 0, void 0, void 0, function () {
            var absoluteManifestPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        absoluteManifestPath = path.resolve('./testProject/manifest');
                        options.files = [
                            {
                                src: absoluteManifestPath,
                                dest: ''
                            },
                            {
                                src: 'source/main.brs',
                                dest: 'source/renamed.brs'
                            }
                        ];
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/manifest')).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('handles excluded folders in glob pattern', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.files = [
                            'manifest',
                            'components/!(scenes)/**/*'
                        ];
                        options.retainStagingFolder = true;
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/components/components/Loader/Loader.brs')).to.exist;
                        expect(file('out/.roku-deploy-staging/components/scenes/Home/Home.brs')).not.to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('handles multi-globs', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.retainStagingFolder = true;
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(__assign(__assign({}, options), { files: [
                                    'manifest',
                                    'source',
                                    'components/**/*',
                                    '!components/scenes/**/*'
                                ] }))];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/components/components/Loader/Loader.brs')).to.exist;
                        expect(file('out/.roku-deploy-staging/components/scenes/Home/Home.brs')).not.to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('throws on invalid entries', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_25;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.files = [
                            'manifest',
                            {}
                        ];
                        options.retainStagingFolder = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 2:
                        _a.sent();
                        expect(true).to.be.false;
                        return [3 /*break*/, 4];
                    case 3:
                        e_25 = _a.sent();
                        expect(true).to.be.true;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('retains subfolder structure when referencing a folder', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.files = [
                            'manifest',
                            {
                                src: 'flavors/shared/resources/**/*',
                                dest: 'resources'
                            }
                        ];
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/resources/images/fhd/image.jpg')).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        it('handles multi-globs subfolder structure', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.files = [
                            'manifest',
                            {
                                //the relative structure after /resources should be retained
                                src: 'flavors/shared/resources/**/*',
                                dest: 'resources'
                            }
                        ];
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging(options)];
                    case 1:
                        _a.sent();
                        expect(file('out/.roku-deploy-staging/resources/images/fhd/image.jpg')).to.exist;
                        expect(file('out/.roku-deploy-staging/resources/image.jpg')).not.to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
        describe('symlinks', function () {
            var sourcePath = util_1.standardizePath(templateObject_14 || (templateObject_14 = __makeTemplateObject(["", "/test.md"], ["", "/test.md"])), cwd);
            var rootDir = util_1.standardizePath(templateObject_15 || (templateObject_15 = __makeTemplateObject(["", "/.tmp/testProject"], ["", "/.tmp/testProject"])), cwd);
            var symlinkPath = util_1.standardizePath(templateObject_16 || (templateObject_16 = __makeTemplateObject(["", "/renamed_test.md"], ["", "/renamed_test.md"])), rootDir);
            beforeEach(cleanUp);
            afterEach(cleanUp);
            function cleanUp() {
                try {
                    fsExtra.removeSync(sourcePath);
                }
                catch (e) { }
                //delete the symlink if it exists
                try {
                    fsExtra.removeSync(symlinkPath);
                }
                catch (e) { }
            }
            var _isSymlinkingPermitted;
            /**
             * Determine if we have permission to create symlinks
             */
            function getIsSymlinksPermitted() {
                if (_isSymlinkingPermitted === undefined) {
                    fsExtra.ensureDirSync(tmpPath + "/a/b/c");
                    fsExtra.ensureDirSync(tmpPath + "/project");
                    fsExtra.writeFileSync(tmpPath + "/a/alpha.txt", 'alpha.txt');
                    fsExtra.writeFileSync(tmpPath + "/a/b/c/charlie.txt", 'charlie.txt');
                    try {
                        //make a file symlink
                        fsExtra.symlinkSync(tmpPath + "/a/alpha.txt", tmpPath + "/project/alpha.txt");
                        //create a folder symlink that also includes subfolders
                        fsExtra.symlinkSync(tmpPath + "/a", tmpPath + "/project/a");
                        //use glob to scan the directory recursively
                        glob.sync('**/*', {
                            cwd: util_1.standardizePath(templateObject_17 || (templateObject_17 = __makeTemplateObject(["", "/project"], ["", "/project"])), tmpPath),
                            absolute: true,
                            follow: true
                        });
                        _isSymlinkingPermitted = true;
                    }
                    catch (e) {
                        _isSymlinkingPermitted = false;
                        return false;
                    }
                }
                return _isSymlinkingPermitted;
            }
            function symlinkIt(name, callback) {
                if (getIsSymlinksPermitted()) {
                    console.log("symlinks are permitted for test \"" + name + "\"");
                    it(name, callback);
                }
                else {
                    console.log("symlinks are not permitted for test \"" + name + "\"");
                    it.skip(name, callback);
                }
            }
            symlinkIt('direct symlinked files are dereferenced properly', function () { return __awaiter(void 0, void 0, void 0, function () {
                var opts, stagingFolderPath, _a, stagedFilePath, fileContents;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: 
                        //make sure the output dir exists
                        return [4 /*yield*/, fsExtra.ensureDir(path.dirname(symlinkPath))];
                        case 1:
                            //make sure the output dir exists
                            _b.sent();
                            //create the actual file
                            return [4 /*yield*/, fsExtra.writeFile(sourcePath, 'hello symlink')];
                        case 2:
                            //create the actual file
                            _b.sent();
                            //the source file should exist
                            expect(file(sourcePath)).to.exist;
                            //create the symlink in testProject
                            return [4 /*yield*/, fsExtra.symlink(sourcePath, symlinkPath)];
                        case 3:
                            //create the symlink in testProject
                            _b.sent();
                            //the symlink file should exist
                            expect(file(symlinkPath)).to.exist;
                            opts = __assign(__assign({}, options), { rootDir: rootDir, files: [
                                    'manifest',
                                    'renamed_test.md'
                                ] });
                            stagingFolderPath = rokuDeploy.getOptions(opts).stagingFolderPath;
                            //getFilePaths detects the file
                            _a = expect;
                            return [4 /*yield*/, rokuDeploy.getFilePaths(['renamed_test.md'], opts.rootDir)];
                        case 4:
                            //getFilePaths detects the file
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_18 || (templateObject_18 = __makeTemplateObject(["", "/renamed_test.md"], ["", "/renamed_test.md"])), opts.rootDir),
                                    dest: util_1.standardizePath(templateObject_19 || (templateObject_19 = __makeTemplateObject(["renamed_test.md"], ["renamed_test.md"])))
                                }]);
                            return [4 /*yield*/, rokuDeploy.prepublishToStaging(opts)];
                        case 5:
                            _b.sent();
                            stagedFilePath = util_1.standardizePath(templateObject_20 || (templateObject_20 = __makeTemplateObject(["", "/renamed_test.md"], ["", "/renamed_test.md"])), stagingFolderPath);
                            expect(file(stagedFilePath)).to.exist;
                            return [4 /*yield*/, fsExtra.readFile(stagedFilePath)];
                        case 6:
                            fileContents = _b.sent();
                            expect(fileContents.toString()).to.equal('hello symlink');
                            return [2 /*return*/];
                    }
                });
            }); });
            symlinkIt('copies files from subdirs of symlinked folders', function () { return __awaiter(void 0, void 0, void 0, function () {
                var opts, stagingPath, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            fsExtra.ensureDirSync(util_1.standardizePath(templateObject_21 || (templateObject_21 = __makeTemplateObject(["", "/baseProject/source/lib/promise"], ["", "/baseProject/source/lib/promise"])), tmpPath));
                            fsExtra.writeFileSync(util_1.standardizePath(templateObject_22 || (templateObject_22 = __makeTemplateObject(["", "/baseProject/source/lib/lib.brs"], ["", "/baseProject/source/lib/lib.brs"])), tmpPath), "'lib.brs");
                            fsExtra.writeFileSync(util_1.standardizePath(templateObject_23 || (templateObject_23 = __makeTemplateObject(["", "/baseProject/source/lib/promise/promise.brs"], ["", "/baseProject/source/lib/promise/promise.brs"])), tmpPath), "'q.brs");
                            fsExtra.ensureDirSync(util_1.standardizePath(templateObject_24 || (templateObject_24 = __makeTemplateObject(["", "/mainProject/source"], ["", "/mainProject/source"])), tmpPath));
                            fsExtra.writeFileSync(util_1.standardizePath(templateObject_25 || (templateObject_25 = __makeTemplateObject(["", "/mainProject/source/main.brs"], ["", "/mainProject/source/main.brs"])), tmpPath), "'main.brs");
                            //symlink the baseProject lib folder into the mainProject
                            fsExtra.symlinkSync(util_1.standardizePath(templateObject_26 || (templateObject_26 = __makeTemplateObject(["", "/baseProject/source/lib"], ["", "/baseProject/source/lib"])), tmpPath), util_1.standardizePath(templateObject_27 || (templateObject_27 = __makeTemplateObject(["", "/mainProject/source/lib"], ["", "/mainProject/source/lib"])), tmpPath));
                            //the symlinked file should exist in the main project
                            expect(fsExtra.pathExistsSync(util_1.standardizePath(templateObject_28 || (templateObject_28 = __makeTemplateObject(["", "/baseProject/source/lib/promise/promise.brs"], ["", "/baseProject/source/lib/promise/promise.brs"])), tmpPath))).to.be.true;
                            opts = __assign(__assign({}, options), { rootDir: util_1.standardizePath(templateObject_29 || (templateObject_29 = __makeTemplateObject(["", "/mainProject"], ["", "/mainProject"])), tmpPath), files: [
                                    'manifest',
                                    'source/**/*'
                                ] });
                            stagingPath = rokuDeploy.getOptions(opts).stagingFolderPath;
                            //getFilePaths detects the file
                            _a = expect;
                            return [4 /*yield*/, rokuDeploy.getFilePaths(opts.files, opts.rootDir)];
                        case 1:
                            //getFilePaths detects the file
                            _a.apply(void 0, [(_b.sent()).sort(function (a, b) { return a.src.localeCompare(b.src); })]).to.eql([{
                                    src: util_1.standardizePath(templateObject_30 || (templateObject_30 = __makeTemplateObject(["", "/mainProject/source/lib/lib.brs"], ["", "/mainProject/source/lib/lib.brs"])), tmpPath),
                                    dest: util_1.standardizePath(templateObject_31 || (templateObject_31 = __makeTemplateObject(["source/lib/lib.brs"], ["source/lib/lib.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_32 || (templateObject_32 = __makeTemplateObject(["", "/mainProject/source/lib/promise/promise.brs"], ["", "/mainProject/source/lib/promise/promise.brs"])), tmpPath),
                                    dest: util_1.standardizePath(templateObject_33 || (templateObject_33 = __makeTemplateObject(["source/lib/promise/promise.brs"], ["source/lib/promise/promise.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_34 || (templateObject_34 = __makeTemplateObject(["", "/mainProject/source/main.brs"], ["", "/mainProject/source/main.brs"])), tmpPath),
                                    dest: util_1.standardizePath(templateObject_35 || (templateObject_35 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"])))
                                }]);
                            return [4 /*yield*/, rokuDeploy.prepublishToStaging(opts)];
                        case 2:
                            _b.sent();
                            expect(fsExtra.pathExistsSync(stagingPath + "/source/lib/promise/promise.brs"));
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
    describe('normalizeFilesArray', function () {
        it('catches invalid dest entries', function () {
            expect(function () {
                rd.normalizeFilesArray([{
                        src: 'some/path',
                        dest: true
                    }]);
            }).to.throw();
            expect(function () {
                rd.normalizeFilesArray([{
                        src: 'some/path',
                        dest: false
                    }]);
            }).to.throw();
            expect(function () {
                rd.normalizeFilesArray([{
                        src: 'some/path',
                        dest: /asdf/gi
                    }]);
            }).to.throw();
            expect(function () {
                rd.normalizeFilesArray([{
                        src: 'some/path',
                        dest: {}
                    }]);
            }).to.throw();
            expect(function () {
                rd.normalizeFilesArray([{
                        src: 'some/path',
                        dest: []
                    }]);
            }).to.throw();
        });
        it('normalizes directory separators paths', function () {
            expect(rd.normalizeFilesArray([{
                    src: "long/source/path",
                    dest: "long/dest/path"
                }])).to.eql([{
                    src: util_1.standardizePath(templateObject_36 || (templateObject_36 = __makeTemplateObject(["long/source/path"], ["long/source/path"]))),
                    dest: util_1.standardizePath(templateObject_37 || (templateObject_37 = __makeTemplateObject(["long/dest/path"], ["long/dest/path"])))
                }]);
        });
        it('works for simple strings', function () {
            expect(rd.normalizeFilesArray([
                'manifest',
                'source/main.brs'
            ])).to.eql([
                'manifest',
                'source/main.brs'
            ]);
        });
        it('works for negated strings', function () {
            expect(rd.normalizeFilesArray([
                '!.git'
            ])).to.eql([
                '!.git'
            ]);
        });
        it('skips falsey and bogus entries', function () {
            expect(rd.normalizeFilesArray([
                '',
                'manifest',
                false,
                undefined,
                null
            ])).to.eql([
                'manifest'
            ]);
        });
        it('works for {src:string} objects', function () {
            expect(rd.normalizeFilesArray([
                {
                    src: 'manifest'
                }
            ])).to.eql([{
                    src: 'manifest',
                    dest: undefined
                }]);
        });
        it('works for {src:string[]} objects', function () {
            expect(rd.normalizeFilesArray([
                {
                    src: [
                        'manifest',
                        'source/main.brs'
                    ]
                }
            ])).to.eql([{
                    src: 'manifest',
                    dest: undefined
                }, {
                    src: util_1.standardizePath(templateObject_38 || (templateObject_38 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"]))),
                    dest: undefined
                }]);
        });
        it('retains dest option', function () {
            expect(rd.normalizeFilesArray([
                {
                    src: 'source/config.dev.brs',
                    dest: 'source/config.brs'
                }
            ])).to.eql([{
                    src: util_1.standardizePath(templateObject_39 || (templateObject_39 = __makeTemplateObject(["source/config.dev.brs"], ["source/config.dev.brs"]))),
                    dest: util_1.standardizePath(templateObject_40 || (templateObject_40 = __makeTemplateObject(["source/config.brs"], ["source/config.brs"])))
                }]);
        });
        it('throws when encountering invalid entries', function () {
            expect(function () { return rd.normalizeFilesArray([true]); }).to.throw();
            expect(function () { return rd.normalizeFilesArray([/asdf/]); }).to.throw();
            expect(function () { return rd.normalizeFilesArray([new Date()]); }).to.throw();
            expect(function () { return rd.normalizeFilesArray([1]); }).to.throw();
            expect(function () { return rd.normalizeFilesArray([{ src: true }]); }).to.throw();
            expect(function () { return rd.normalizeFilesArray([{ src: /asdf/ }]); }).to.throw();
            expect(function () { return rd.normalizeFilesArray([{ src: new Date() }]); }).to.throw();
            expect(function () { return rd.normalizeFilesArray([{ src: 1 }]); }).to.throw();
        });
    });
    describe('deploy', function () {
        it('does the whole migration', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mockDoPostRequest();
                        return [4 /*yield*/, rokuDeploy.deploy()];
                    case 1:
                        result = _a.sent();
                        expect(result).not.to.be.undefined;
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('deleteInstalledChannel', function () {
        it('attempts to delete any installed dev channel on the device', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mockDoPostRequest();
                        return [4 /*yield*/, rokuDeploy.deleteInstalledChannel()];
                    case 1:
                        result = _a.sent();
                        expect(result).not.to.be.undefined;
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('zipFolder', function () {
        //this is mainly done to hit 100% coverage, but why not ensure the errors are handled properly? :D
        it('rejects the promise when an error occurs', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    //zip path doesn't exist
                    return [4 /*yield*/, assertThrowsAsync(function () { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, rokuDeploy.zipFolder('source', '.tmp/some/zip/path/that/does/not/exist')];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 1:
                        //zip path doesn't exist
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('allows modification of file contents with callback', function () { return __awaiter(void 0, void 0, void 0, function () {
            var stageFolder, files, _i, files_3, file_3, outputZipPath, addedManifestLine, data, zip, _a, files_4, file_4, zipFileContents, sourcePath, incomingContents;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        stageFolder = path.join(tmpPath, 'testProject');
                        fsExtra.ensureDirSync(stageFolder);
                        files = [
                            'components/components/Loader/Loader.brs',
                            'images/splash_hd.jpg',
                            'source/main.brs',
                            'manifest'
                        ];
                        for (_i = 0, files_3 = files; _i < files_3.length; _i++) {
                            file_3 = files_3[_i];
                            fsExtra.copySync(path.join(options.rootDir, file_3), path.join(stageFolder, file_3));
                        }
                        outputZipPath = path.join(tmpPath, 'output.zip');
                        addedManifestLine = 'bs_libs_required=roku_ads_lib';
                        return [4 /*yield*/, rokuDeploy.zipFolder(stageFolder, outputZipPath, function (file, data) {
                                if (file.dest === 'manifest') {
                                    var manifestContents = data.toString();
                                    manifestContents += addedManifestLine;
                                    data = Buffer.from(manifestContents, 'utf8');
                                }
                                return data;
                            })];
                    case 1:
                        _b.sent();
                        data = fsExtra.readFileSync(outputZipPath);
                        return [4 /*yield*/, JSZip.loadAsync(data)];
                    case 2:
                        zip = _b.sent();
                        _a = 0, files_4 = files;
                        _b.label = 3;
                    case 3:
                        if (!(_a < files_4.length)) return [3 /*break*/, 6];
                        file_4 = files_4[_a];
                        return [4 /*yield*/, zip.file(file_4.toString()).async('string')];
                    case 4:
                        zipFileContents = _b.sent();
                        sourcePath = path.join(options.rootDir, file_4);
                        incomingContents = fsExtra.readFileSync(sourcePath, 'utf8');
                        if (file_4 === 'manifest') {
                            expect(zipFileContents).to.contain(addedManifestLine);
                        }
                        else {
                            expect(zipFileContents).to.equal(incomingContents);
                        }
                        _b.label = 5;
                    case 5:
                        _a++;
                        return [3 /*break*/, 3];
                    case 6: return [2 /*return*/];
                }
            });
        }); });
    });
    describe('parseManifest', function () {
        it('correctly parses valid manifest', function () { return __awaiter(void 0, void 0, void 0, function () {
            var rootProjectDir, manifestPath, parsedManifest;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        rootProjectDir = path.resolve(options.rootDir);
                        manifestPath = path.join(rootProjectDir, 'manifest');
                        return [4 /*yield*/, rokuDeploy.parseManifest(manifestPath)];
                    case 1:
                        parsedManifest = _a.sent();
                        expect(parsedManifest.title).to.equal('RokuDeployTestChannel');
                        expect(parsedManifest.major_version).to.equal('1');
                        expect(parsedManifest.minor_version).to.equal('0');
                        expect(parsedManifest.build_version).to.equal('0');
                        expect(parsedManifest.splash_screen_hd).to.equal('pkg:/images/splash_hd.jpg');
                        expect(parsedManifest.ui_resolutions).to.equal('hd');
                        expect(parsedManifest.bs_const).to.equal('IS_DEV_BUILD=false');
                        expect(parsedManifest.splash_color).to.equal('#000000');
                        return [2 /*return*/];
                }
            });
        }); });
        it('Throws our error message for a missing file', function () { return __awaiter(void 0, void 0, void 0, function () {
            var invalidManifestPath, e_26;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        invalidManifestPath = 'invalid-path';
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.parseManifest(invalidManifestPath)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_26 = _a.sent();
                        expect(e_26.message).to.equal(invalidManifestPath + ' does not exist');
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Exception should have been thrown');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('stringifyManifest', function () {
        var inputManifestContents;
        var inputParsedManifest;
        beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
            var rootProjectDir, manifestPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        rootProjectDir = path.resolve(options.rootDir);
                        manifestPath = path.join(rootProjectDir, 'manifest');
                        return [4 /*yield*/, fsExtra.readFile(manifestPath, 'utf-8')];
                    case 1:
                        inputManifestContents = _a.sent();
                        inputManifestContents = inputManifestContents.trim();
                        inputParsedManifest = rokuDeploy.parseManifestFromString(inputManifestContents);
                        return [2 /*return*/];
                }
            });
        }); });
        it('correctly converts back to a valid manifest when lineNumber and keyIndexes are provided', function () {
            var outputStringifiedManifest = rokuDeploy.stringifyManifest(inputParsedManifest);
            var outputNormalized = outputStringifiedManifest.replace(/\r\n/g, '\n');
            var inputNormalized = inputManifestContents.replace(/\r\n/g, '\n');
            expect(outputNormalized).to.equal(inputNormalized);
        });
        it('correctly converts back to a valid manifest when lineNumber and keyIndexes are not provided', function () {
            delete inputParsedManifest.keyIndexes;
            delete inputParsedManifest.lineCount;
            var outputStringifiedManifest = rokuDeploy.stringifyManifest(inputParsedManifest);
            var outputParsedManifest = rokuDeploy.parseManifestFromString(outputStringifiedManifest);
            expect(outputParsedManifest.title).to.equal(inputParsedManifest.title);
            expect(outputParsedManifest.major_version).to.equal(inputParsedManifest.major_version);
            expect(outputParsedManifest.minor_version).to.equal(inputParsedManifest.minor_version);
            expect(outputParsedManifest.build_version).to.equal(inputParsedManifest.build_version);
            expect(outputParsedManifest.splash_screen_hd).to.equal(inputParsedManifest.splash_screen_hd);
            expect(outputParsedManifest.ui_resolutions).to.equal(inputParsedManifest.ui_resolutions);
            expect(outputParsedManifest.bs_const).to.equal(inputParsedManifest.bs_const);
        });
    });
    describe('getFilePaths', function () {
        var tempPath = util_1.standardizePath(templateObject_41 || (templateObject_41 = __makeTemplateObject(["", "/getFilePaths_temp"], ["", "/getFilePaths_temp"])), cwd);
        var rootDir = util_1.standardizePath(templateObject_42 || (templateObject_42 = __makeTemplateObject(["", "/src"], ["", "/src"])), tempPath);
        var stagingPathAbsolute = util_1.standardizePath(templateObject_43 || (templateObject_43 = __makeTemplateObject(["", "/staging"], ["", "/staging"])), tmpPath);
        var otherProjectDir = util_1.standardizePath(templateObject_44 || (templateObject_44 = __makeTemplateObject(["", "/otherProjectSrc"], ["", "/otherProjectSrc"])), tempPath);
        //create baseline project structure
        before(function () {
            fsExtra.removeSync(tempPath);
            //srcSync
            fsExtra.ensureDirSync(rootDir + "/source");
            fsExtra.ensureDirSync(rootDir + "/components/screen1");
            fsExtra.ensureDirSync(rootDir + "/components/emptyFolder");
            fsExtra.writeFileSync(rootDir + "/manifest", '');
            fsExtra.writeFileSync(rootDir + "/source/main.brs", '');
            fsExtra.writeFileSync(rootDir + "/source/lib.brs", '');
            fsExtra.writeFileSync(rootDir + "/components/component1.xml", '');
            fsExtra.writeFileSync(rootDir + "/components/component1.brs", '');
            fsExtra.writeFileSync(rootDir + "/components/screen1/screen1.xml", '');
            fsExtra.writeFileSync(rootDir + "/components/screen1/screen1.brs", '');
            //otherProjectSrc
            fsExtra.ensureDirSync(otherProjectDir + "/source");
            fsExtra.writeFileSync(otherProjectDir + "/manifest", '');
            fsExtra.writeFileSync(otherProjectDir + "/source/thirdPartyLib.brs", '');
            fsExtra.ensureDirSync(otherProjectDir + "/components/component1/subComponent");
            fsExtra.writeFileSync(otherProjectDir + "/components/component1/subComponent/screen.brs", '');
        });
        after(function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fsExtra.remove(tempPath)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        function getFilePaths(files, rootDirOverride) {
            if (rootDirOverride === void 0) { rootDirOverride = rootDir; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, rokuDeploy.getFilePaths(files, rootDirOverride)];
                        case 1: return [2 /*return*/, (_a.sent())
                                .sort(function (a, b) { return a.src.localeCompare(b.src); })];
                    }
                });
            });
        }
        describe('top-level-patterns', function () {
            it('works for root-level double star', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    '**/*'
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_45 || (templateObject_45 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_46 || (templateObject_46 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_47 || (templateObject_47 = __makeTemplateObject(["", "/components/component1.xml"], ["", "/components/component1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_48 || (templateObject_48 = __makeTemplateObject(["components/component1.xml"], ["components/component1.xml"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_49 || (templateObject_49 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_50 || (templateObject_50 = __makeTemplateObject(["components/screen1/screen1.brs"], ["components/screen1/screen1.brs"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_51 || (templateObject_51 = __makeTemplateObject(["", "/components/screen1/screen1.xml"], ["", "/components/screen1/screen1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_52 || (templateObject_52 = __makeTemplateObject(["components/screen1/screen1.xml"], ["components/screen1/screen1.xml"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_53 || (templateObject_53 = __makeTemplateObject(["", "/manifest"], ["", "/manifest"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_54 || (templateObject_54 = __makeTemplateObject(["manifest"], ["manifest"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_55 || (templateObject_55 = __makeTemplateObject(["", "/source/lib.brs"], ["", "/source/lib.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_56 || (templateObject_56 = __makeTemplateObject(["source/lib.brs"], ["source/lib.brs"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_57 || (templateObject_57 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_58 || (templateObject_58 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('works for multile entries', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    'source/**/*',
                                    'components/**/*',
                                    'manifest'
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_59 || (templateObject_59 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_60 || (templateObject_60 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_61 || (templateObject_61 = __makeTemplateObject(["", "/components/component1.xml"], ["", "/components/component1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_62 || (templateObject_62 = __makeTemplateObject(["components/component1.xml"], ["components/component1.xml"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_63 || (templateObject_63 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_64 || (templateObject_64 = __makeTemplateObject(["components/screen1/screen1.brs"], ["components/screen1/screen1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_65 || (templateObject_65 = __makeTemplateObject(["", "/components/screen1/screen1.xml"], ["", "/components/screen1/screen1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_66 || (templateObject_66 = __makeTemplateObject(["components/screen1/screen1.xml"], ["components/screen1/screen1.xml"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_67 || (templateObject_67 = __makeTemplateObject(["", "/manifest"], ["", "/manifest"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_68 || (templateObject_68 = __makeTemplateObject(["manifest"], ["manifest"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_69 || (templateObject_69 = __makeTemplateObject(["", "/source/lib.brs"], ["", "/source/lib.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_70 || (templateObject_70 = __makeTemplateObject(["source/lib.brs"], ["source/lib.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_71 || (templateObject_71 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_72 || (templateObject_72 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('copies top-level-string single-star globs', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    'source/*.brs'
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_73 || (templateObject_73 = __makeTemplateObject(["", "/source/lib.brs"], ["", "/source/lib.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_74 || (templateObject_74 = __makeTemplateObject(["source/lib.brs"], ["source/lib.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_75 || (templateObject_75 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_76 || (templateObject_76 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('works for double-star globs', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    '**/*.brs'
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_77 || (templateObject_77 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_78 || (templateObject_78 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_79 || (templateObject_79 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_80 || (templateObject_80 = __makeTemplateObject(["components/screen1/screen1.brs"], ["components/screen1/screen1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_81 || (templateObject_81 = __makeTemplateObject(["", "/source/lib.brs"], ["", "/source/lib.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_82 || (templateObject_82 = __makeTemplateObject(["source/lib.brs"], ["source/lib.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_83 || (templateObject_83 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_84 || (templateObject_84 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('copies subdir-level relative double-star globs', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    'components/**/*.brs'
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_85 || (templateObject_85 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_86 || (templateObject_86 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_87 || (templateObject_87 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_88 || (templateObject_88 = __makeTemplateObject(["components/screen1/screen1.brs"], ["components/screen1/screen1.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('throws exception when top-level strings reference files not under rootDir', function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, expectThrowsAsync(function () { return __awaiter(void 0, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, getFilePaths([
                                                "../otherProjectSrc/**/*"
                                            ])];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('applies negated patterns', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    //include all components
                                    'components/**/*.brs',
                                    //exclude all xml files
                                    '!components/**/*.xml',
                                    //re-include a specific xml file
                                    'components/screen1/screen1.xml'
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_89 || (templateObject_89 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_90 || (templateObject_90 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_91 || (templateObject_91 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_92 || (templateObject_92 = __makeTemplateObject(["components/screen1/screen1.brs"], ["components/screen1/screen1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_93 || (templateObject_93 = __makeTemplateObject(["", "/components/screen1/screen1.xml"], ["", "/components/screen1/screen1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_94 || (templateObject_94 = __makeTemplateObject(["components/screen1/screen1.xml"], ["components/screen1/screen1.xml"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('handles negated multi-globs', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    'components/**/*',
                                    '!components/screen1/**/*'
                                ])];
                        case 1:
                            _a.apply(void 0, [(_b.sent()).map(function (x) { return x.dest; })]).to.eql([
                                util_1.standardizePath(templateObject_95 || (templateObject_95 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"]))),
                                util_1.standardizePath(templateObject_96 || (templateObject_96 = __makeTemplateObject(["components/component1.xml"], ["components/component1.xml"])))
                            ]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('applies multi-glob paths relative to rootDir', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    'manifest',
                                    'source/**/*',
                                    'components/**/*',
                                    '!components/scenes/**/*'
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_97 || (templateObject_97 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_98 || (templateObject_98 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_99 || (templateObject_99 = __makeTemplateObject(["", "/components/component1.xml"], ["", "/components/component1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_100 || (templateObject_100 = __makeTemplateObject(["components/component1.xml"], ["components/component1.xml"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_101 || (templateObject_101 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_102 || (templateObject_102 = __makeTemplateObject(["components/screen1/screen1.brs"], ["components/screen1/screen1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_103 || (templateObject_103 = __makeTemplateObject(["", "/components/screen1/screen1.xml"], ["", "/components/screen1/screen1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_104 || (templateObject_104 = __makeTemplateObject(["components/screen1/screen1.xml"], ["components/screen1/screen1.xml"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_105 || (templateObject_105 = __makeTemplateObject(["", "/manifest"], ["", "/manifest"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_106 || (templateObject_106 = __makeTemplateObject(["manifest"], ["manifest"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_107 || (templateObject_107 = __makeTemplateObject(["", "/source/lib.brs"], ["", "/source/lib.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_108 || (templateObject_108 = __makeTemplateObject(["source/lib.brs"], ["source/lib.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_109 || (templateObject_109 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_110 || (templateObject_110 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('ignores non-glob folder paths', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    //this is the folder called "components"
                                    'components'
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([]); //there should be no matches because rokudeploy ignores folders
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        describe('{src;dest} objects', function () {
            it('works for root-level double star', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([{
                                        src: '**/*',
                                        dest: ''
                                    }
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_111 || (templateObject_111 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_112 || (templateObject_112 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_113 || (templateObject_113 = __makeTemplateObject(["", "/components/component1.xml"], ["", "/components/component1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_114 || (templateObject_114 = __makeTemplateObject(["components/component1.xml"], ["components/component1.xml"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_115 || (templateObject_115 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_116 || (templateObject_116 = __makeTemplateObject(["components/screen1/screen1.brs"], ["components/screen1/screen1.brs"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_117 || (templateObject_117 = __makeTemplateObject(["", "/components/screen1/screen1.xml"], ["", "/components/screen1/screen1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_118 || (templateObject_118 = __makeTemplateObject(["components/screen1/screen1.xml"], ["components/screen1/screen1.xml"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_119 || (templateObject_119 = __makeTemplateObject(["", "/manifest"], ["", "/manifest"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_120 || (templateObject_120 = __makeTemplateObject(["manifest"], ["manifest"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_121 || (templateObject_121 = __makeTemplateObject(["", "/source/lib.brs"], ["", "/source/lib.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_122 || (templateObject_122 = __makeTemplateObject(["source/lib.brs"], ["source/lib.brs"])))
                                },
                                {
                                    src: util_1.standardizePath(templateObject_123 || (templateObject_123 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_124 || (templateObject_124 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('uses the root of staging folder for dest when not specified with star star', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([{
                                        src: otherProjectDir + "/**/*"
                                    }])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_125 || (templateObject_125 = __makeTemplateObject(["", "/components/component1/subComponent/screen.brs"], ["", "/components/component1/subComponent/screen.brs"])), otherProjectDir),
                                    dest: util_1.standardizePath(templateObject_126 || (templateObject_126 = __makeTemplateObject(["components/component1/subComponent/screen.brs"], ["components/component1/subComponent/screen.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_127 || (templateObject_127 = __makeTemplateObject(["", "/manifest"], ["", "/manifest"])), otherProjectDir),
                                    dest: util_1.standardizePath(templateObject_128 || (templateObject_128 = __makeTemplateObject(["manifest"], ["manifest"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_129 || (templateObject_129 = __makeTemplateObject(["", "/source/thirdPartyLib.brs"], ["", "/source/thirdPartyLib.brs"])), otherProjectDir),
                                    dest: util_1.standardizePath(templateObject_130 || (templateObject_130 = __makeTemplateObject(["source/thirdPartyLib.brs"], ["source/thirdPartyLib.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('copies absolute path files to specified dest', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([{
                                        src: otherProjectDir + "/source/thirdPartyLib.brs",
                                        dest: 'lib/thirdPartyLib.brs'
                                    }])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_131 || (templateObject_131 = __makeTemplateObject(["", "/source/thirdPartyLib.brs"], ["", "/source/thirdPartyLib.brs"])), otherProjectDir),
                                    dest: util_1.standardizePath(templateObject_132 || (templateObject_132 = __makeTemplateObject(["lib/thirdPartyLib.brs"], ["lib/thirdPartyLib.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('copies relative path files to specified dest', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([{
                                        src: otherProjectDir + "/../src/source/main.brs",
                                        dest: 'source/main.brs'
                                    }])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_133 || (templateObject_133 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_134 || (templateObject_134 = __makeTemplateObject(["source/main.brs"], ["source/main.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('maintains relative path after **', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([{
                                        src: "../otherProjectSrc/**/*",
                                        dest: 'outFolder/'
                                    }])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_135 || (templateObject_135 = __makeTemplateObject(["", "/components/component1/subComponent/screen.brs"], ["", "/components/component1/subComponent/screen.brs"])), otherProjectDir),
                                    dest: util_1.standardizePath(templateObject_136 || (templateObject_136 = __makeTemplateObject(["outFolder/components/component1/subComponent/screen.brs"], ["outFolder/components/component1/subComponent/screen.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_137 || (templateObject_137 = __makeTemplateObject(["", "/manifest"], ["", "/manifest"])), otherProjectDir),
                                    dest: util_1.standardizePath(templateObject_138 || (templateObject_138 = __makeTemplateObject(["outFolder/manifest"], ["outFolder/manifest"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_139 || (templateObject_139 = __makeTemplateObject(["", "/source/thirdPartyLib.brs"], ["", "/source/thirdPartyLib.brs"])), otherProjectDir),
                                    dest: util_1.standardizePath(templateObject_140 || (templateObject_140 = __makeTemplateObject(["outFolder/source/thirdPartyLib.brs"], ["outFolder/source/thirdPartyLib.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('works for other globs', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([{
                                        src: "components/screen1/*creen1.brs",
                                        dest: util_1.standardizePath(templateObject_141 || (templateObject_141 = __makeTemplateObject(["/source"], ["/source"])))
                                    }])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_142 || (templateObject_142 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_143 || (templateObject_143 = __makeTemplateObject(["source/screen1.brs"], ["source/screen1.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('works for other globs without dest', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([{
                                        src: "components/screen1/*creen1.brs"
                                    }])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_144 || (templateObject_144 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_145 || (templateObject_145 = __makeTemplateObject(["screen1.brs"], ["screen1.brs"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('skips directory folder names for other globs without dest', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([{
                                        //straight wildcard matches folder names too
                                        src: "components/*"
                                    }])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_146 || (templateObject_146 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_147 || (templateObject_147 = __makeTemplateObject(["component1.brs"], ["component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_148 || (templateObject_148 = __makeTemplateObject(["", "/components/component1.xml"], ["", "/components/component1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_149 || (templateObject_149 = __makeTemplateObject(["component1.xml"], ["component1.xml"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('applies negated patterns', function () { return __awaiter(void 0, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = expect;
                            return [4 /*yield*/, getFilePaths([
                                    //include all components
                                    { src: 'components/**/*.brs', dest: 'components' },
                                    //exclude all xml files
                                    '!components/**/*.xml',
                                    //re-include a specific xml file
                                    { src: 'components/screen1/screen1.xml', dest: 'components/screen1/screen1.xml' }
                                ])];
                        case 1:
                            _a.apply(void 0, [_b.sent()]).to.eql([{
                                    src: util_1.standardizePath(templateObject_150 || (templateObject_150 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_151 || (templateObject_151 = __makeTemplateObject(["components/component1.brs"], ["components/component1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_152 || (templateObject_152 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_153 || (templateObject_153 = __makeTemplateObject(["components/screen1/screen1.brs"], ["components/screen1/screen1.brs"])))
                                }, {
                                    src: util_1.standardizePath(templateObject_154 || (templateObject_154 = __makeTemplateObject(["", "/components/screen1/screen1.xml"], ["", "/components/screen1/screen1.xml"])), rootDir),
                                    dest: util_1.standardizePath(templateObject_155 || (templateObject_155 = __makeTemplateObject(["components/screen1/screen1.xml"], ["components/screen1/screen1.xml"])))
                                }]);
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        it('converts relative rootDir path to absolute', function () { return __awaiter(void 0, void 0, void 0, function () {
            var stub;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        stub = sinon.stub(rokuDeploy, 'getOptions').callThrough();
                        return [4 /*yield*/, getFilePaths([
                                'source/main.brs'
                            ], './rootDir')];
                    case 1:
                        _a.sent();
                        expect(stub.callCount).to.be.greaterThan(0);
                        expect(stub.getCall(0).args[0].rootDir).to.eql('./rootDir');
                        expect(stub.getCall(0).returnValue.rootDir).to.eql(util_1.standardizePath(templateObject_156 || (templateObject_156 = __makeTemplateObject(["", "/rootDir"], ["", "/rootDir"])), cwd));
                        return [2 /*return*/];
                }
            });
        }); });
        it('works when using a different current working directory than rootDir', function () { return __awaiter(void 0, void 0, void 0, function () {
            var rootProjectDir, paths, wrongCwd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        rootProjectDir = path.resolve(options.rootDir);
                        return [4 /*yield*/, rokuDeploy.getFilePaths([
                                'manifest',
                                'images/splash_hd.jpg'
                            ], rootProjectDir)];
                    case 1:
                        paths = (_a.sent()).sort(function (a, b) { return a.src.localeCompare(b.src); });
                        expect(paths).to.eql([{
                                src: util_1.standardizePath(templateObject_157 || (templateObject_157 = __makeTemplateObject(["", "/images/splash_hd.jpg"], ["", "/images/splash_hd.jpg"])), rootProjectDir),
                                dest: util_1.standardizePath(templateObject_158 || (templateObject_158 = __makeTemplateObject(["images/splash_hd.jpg"], ["images/splash_hd.jpg"])))
                            }, {
                                src: util_1.standardizePath(templateObject_159 || (templateObject_159 = __makeTemplateObject(["", "/manifest"], ["", "/manifest"])), rootProjectDir),
                                dest: util_1.standardizePath(templateObject_160 || (templateObject_160 = __makeTemplateObject(["manifest"], ["manifest"])))
                            }]);
                        wrongCwd = path.dirname(path.resolve(options.rootDir));
                        process.chdir(wrongCwd);
                        return [4 /*yield*/, rokuDeploy.getFilePaths([
                                'manifest',
                                'images/splash_hd.jpg'
                            ], rootProjectDir)];
                    case 2:
                        paths = (_a.sent()).sort(function (a, b) { return a.src.localeCompare(b.src); });
                        expect(paths).to.eql([{
                                src: util_1.standardizePath(templateObject_161 || (templateObject_161 = __makeTemplateObject(["", "/images/splash_hd.jpg"], ["", "/images/splash_hd.jpg"])), rootProjectDir),
                                dest: util_1.standardizePath(templateObject_162 || (templateObject_162 = __makeTemplateObject(["images/splash_hd.jpg"], ["images/splash_hd.jpg"])))
                            }, {
                                src: util_1.standardizePath(templateObject_163 || (templateObject_163 = __makeTemplateObject(["", "/manifest"], ["", "/manifest"])), rootProjectDir),
                                dest: util_1.standardizePath(templateObject_164 || (templateObject_164 = __makeTemplateObject(["manifest"], ["manifest"])))
                            }]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('supports absolute paths from outside of the rootDir', function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a, _b, outDir, paths;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        options = rokuDeploy.getOptions(options);
                        //dest not specified
                        _a = expect;
                        return [4 /*yield*/, rokuDeploy.getFilePaths([{
                                    src: util_1.standardizePath(templateObject_165 || (templateObject_165 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd)
                                }], options.rootDir)];
                    case 1:
                        //dest not specified
                        _a.apply(void 0, [_c.sent()]).to.eql([{
                                src: util_1.standardizePath(templateObject_166 || (templateObject_166 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd),
                                dest: util_1.standardizePath(templateObject_167 || (templateObject_167 = __makeTemplateObject(["README.md"], ["README.md"])))
                            }]);
                        //dest specified
                        _b = expect;
                        return [4 /*yield*/, rokuDeploy.getFilePaths([{
                                    src: path.join(cwd, 'README.md'),
                                    dest: 'docs/README.md'
                                }], options.rootDir)];
                    case 2:
                        //dest specified
                        _b.apply(void 0, [_c.sent()]).to.eql([{
                                src: util_1.standardizePath(templateObject_168 || (templateObject_168 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd),
                                dest: util_1.standardizePath(templateObject_169 || (templateObject_169 = __makeTemplateObject(["docs/README.md"], ["docs/README.md"])))
                            }]);
                        outDir = path.resolve(options.outDir);
                        return [4 /*yield*/, rokuDeploy.getFilePaths([{
                                    src: util_1.standardizePath(templateObject_170 || (templateObject_170 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd),
                                    dest: util_1.standardizePath(templateObject_171 || (templateObject_171 = __makeTemplateObject(["docs/README.md"], ["docs/README.md"])))
                                }], outDir)];
                    case 3:
                        paths = _c.sent();
                        expect(paths).to.eql([{
                                src: util_1.standardizePath(templateObject_172 || (templateObject_172 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd),
                                dest: util_1.standardizePath(templateObject_173 || (templateObject_173 = __makeTemplateObject(["docs/README.md"], ["docs/README.md"])))
                            }]);
                        //top-level string paths pointing to files outside the root should thrown an exception
                        return [4 /*yield*/, expectThrowsAsync(function () { return __awaiter(void 0, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, rokuDeploy.getFilePaths([
                                                util_1.standardizePath(templateObject_174 || (templateObject_174 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd)
                                            ], outDir)];
                                        case 1:
                                            paths = _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                    case 4:
                        //top-level string paths pointing to files outside the root should thrown an exception
                        _c.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('supports relative paths that grab files from outside of the rootDir', function () { return __awaiter(void 0, void 0, void 0, function () {
            var outDir, rootProjectDir, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        outDir = path.resolve(options.outDir);
                        rootProjectDir = path.resolve(options.rootDir);
                        _a = expect;
                        return [4 /*yield*/, rokuDeploy.getFilePaths([{
                                    src: path.join('..', 'README.md')
                                }], rootProjectDir)];
                    case 1:
                        _a.apply(void 0, [_c.sent()]).to.eql([{
                                src: util_1.standardizePath(templateObject_175 || (templateObject_175 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd),
                                dest: util_1.standardizePath(templateObject_176 || (templateObject_176 = __makeTemplateObject(["README.md"], ["README.md"])))
                            }]);
                        _b = expect;
                        return [4 /*yield*/, rokuDeploy.getFilePaths([{
                                    src: path.join('..', 'README.md'),
                                    dest: 'docs/README.md'
                                }], rootProjectDir)];
                    case 2:
                        _b.apply(void 0, [_c.sent()]).to.eql([{
                                src: util_1.standardizePath(templateObject_177 || (templateObject_177 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd),
                                dest: util_1.standardizePath(templateObject_178 || (templateObject_178 = __makeTemplateObject(["docs/README.md"], ["docs/README.md"])))
                            }]);
                        //should throw exception because we can't have top-level string paths pointed to files outside the root
                        return [4 /*yield*/, expectThrowsAsync(function () { return __awaiter(void 0, void 0, void 0, function () {
                                var paths;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, rokuDeploy.getFilePaths([
                                                path.join('..', 'README.md')
                                            ], outDir)];
                                        case 1:
                                            paths = _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                    case 3:
                        //should throw exception because we can't have top-level string paths pointed to files outside the root
                        _c.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('supports overriding paths', function () { return __awaiter(void 0, void 0, void 0, function () {
            var paths;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, rokuDeploy.getFilePaths([{
                                src: util_1.standardizePath(templateObject_179 || (templateObject_179 = __makeTemplateObject(["", "/components/component1.brs"], ["", "/components/component1.brs"])), rootDir),
                                dest: 'comp1.brs'
                            }, {
                                src: util_1.standardizePath(templateObject_180 || (templateObject_180 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir),
                                dest: 'comp1.brs'
                            }], rootDir)];
                    case 1:
                        paths = _a.sent();
                        expect(paths).to.be.lengthOf(1);
                        expect(util_1.standardizePath(templateObject_181 || (templateObject_181 = __makeTemplateObject(["", ""], ["", ""])), paths[0].src)).to.equal(util_1.standardizePath(templateObject_182 || (templateObject_182 = __makeTemplateObject(["", "/components/screen1/screen1.brs"], ["", "/components/screen1/screen1.brs"])), rootDir));
                        return [2 /*return*/];
                }
            });
        }); });
        it('supports overriding paths from outside the root dir', function () { return __awaiter(void 0, void 0, void 0, function () {
            var thisRootDir, files, paths, mainSceneEntries;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        thisRootDir = util_1.standardizePath(templateObject_183 || (templateObject_183 = __makeTemplateObject(["", "/tempTestOverrides/src"], ["", "/tempTestOverrides/src"])), cwd);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, , 3, 5]);
                        fsExtra.ensureDirSync(util_1.standardizePath(templateObject_184 || (templateObject_184 = __makeTemplateObject(["", "/source"], ["", "/source"])), thisRootDir));
                        fsExtra.ensureDirSync(util_1.standardizePath(templateObject_185 || (templateObject_185 = __makeTemplateObject(["", "/components"], ["", "/components"])), thisRootDir));
                        fsExtra.ensureDirSync(util_1.standardizePath(templateObject_186 || (templateObject_186 = __makeTemplateObject(["", "/../.tmp"], ["", "/../.tmp"])), thisRootDir));
                        fsExtra.writeFileSync(util_1.standardizePath(templateObject_187 || (templateObject_187 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), thisRootDir), '');
                        fsExtra.writeFileSync(util_1.standardizePath(templateObject_188 || (templateObject_188 = __makeTemplateObject(["", "/components/MainScene.brs"], ["", "/components/MainScene.brs"])), thisRootDir), '');
                        fsExtra.writeFileSync(util_1.standardizePath(templateObject_189 || (templateObject_189 = __makeTemplateObject(["", "/components/MainScene.xml"], ["", "/components/MainScene.xml"])), thisRootDir), '');
                        fsExtra.writeFileSync(util_1.standardizePath(templateObject_190 || (templateObject_190 = __makeTemplateObject(["", "/../.tmp/MainScene.brs"], ["", "/../.tmp/MainScene.brs"])), thisRootDir), '');
                        files = [
                            '**/*.xml',
                            '**/*.brs',
                            {
                                src: '../.tmp/MainScene.brs',
                                dest: 'components/MainScene.brs'
                            }
                        ];
                        return [4 /*yield*/, rokuDeploy.getFilePaths(files, thisRootDir)];
                    case 2:
                        paths = _a.sent();
                        mainSceneEntries = paths.filter(function (x) { return util_1.standardizePath(templateObject_191 || (templateObject_191 = __makeTemplateObject(["", ""], ["", ""])), x.dest) === util_1.standardizePath(templateObject_192 || (templateObject_192 = __makeTemplateObject(["components/MainScene.brs"], ["components/MainScene.brs"]))); });
                        expect(mainSceneEntries, "Should only be one files entry for 'components/MainScene.brs'").to.be.lengthOf(1);
                        expect(util_1.standardizePath(templateObject_193 || (templateObject_193 = __makeTemplateObject(["", ""], ["", ""])), mainSceneEntries[0].src)).to.eql(util_1.standardizePath(templateObject_194 || (templateObject_194 = __makeTemplateObject(["", "/../.tmp/MainScene.brs"], ["", "/../.tmp/MainScene.brs"])), thisRootDir));
                        return [3 /*break*/, 5];
                    case 3: 
                    //clean up
                    return [4 /*yield*/, fsExtra.remove(util_1.standardizePath(templateObject_195 || (templateObject_195 = __makeTemplateObject(["", "/../"], ["", "/../"])), thisRootDir))];
                    case 4:
                        //clean up
                        _a.sent();
                        return [7 /*endfinally*/];
                    case 5: return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getDestPath', function () {
        var rootDir = cwd;
        it('finds dest path for top-level path', function () {
            expect(rokuDeploy.getDestPath(util_1.standardizePath(templateObject_196 || (templateObject_196 = __makeTemplateObject(["", "/components/comp1/comp1.brs"], ["", "/components/comp1/comp1.brs"])), rootDir), ['components/**/*'], rootDir)).to.equal(util_1.standardizePath(templateObject_197 || (templateObject_197 = __makeTemplateObject(["components/comp1/comp1.brs"], ["components/comp1/comp1.brs"]))));
        });
        it('does not find dest path for non-matched top-level path', function () {
            expect(rokuDeploy.getDestPath(util_1.standardizePath(templateObject_198 || (templateObject_198 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir), ['components/**/*'], rootDir)).to.be.undefined;
        });
        it('excludes a file that is negated', function () {
            expect(rokuDeploy.getDestPath(util_1.standardizePath(templateObject_199 || (templateObject_199 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir), [
                'source/**/*',
                '!source/main.brs'
            ], rootDir)).to.be.undefined;
        });
        it('excludes a file that is negated in src;dest;', function () {
            expect(rokuDeploy.getDestPath(util_1.standardizePath(templateObject_200 || (templateObject_200 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), rootDir), [
                'source/**/*',
                {
                    src: '!source/main.brs'
                }
            ], rootDir)).to.be.undefined;
        });
        it('works for brighterscript files', function () {
            var destPath = rokuDeploy.getDestPath(util_1.util.standardizePath(cwd + "/src/source/main.bs"), [
                'manifest',
                'source/**/*.bs'
            ], util_1.standardizePath(templateObject_201 || (templateObject_201 = __makeTemplateObject(["", "/src"], ["", "/src"])), cwd));
            expect(util_1.standardizePath(templateObject_202 || (templateObject_202 = __makeTemplateObject(["", ""], ["", ""])), destPath)).to.equal(util_1.standardizePath(templateObject_203 || (templateObject_203 = __makeTemplateObject(["source/main.bs"], ["source/main.bs"]))));
        });
        it('throws exception when rootDir is not absolute', function () {
            var stub = sinon.stub(rokuDeploy, 'getOptions').callThrough();
            var destPath = rokuDeploy.getDestPath(util_1.util.standardizePath(cwd + "/src/source/main.bs"), [
                'manifest',
                'source/**/*.bs'
            ], "./src");
            expect(stub.callCount).to.be.greaterThan(0);
            expect(stub.getCall(0).args[0].rootDir).to.eql('./src');
            expect(stub.getCall(0).returnValue.rootDir).to.eql(util_1.standardizePath(templateObject_204 || (templateObject_204 = __makeTemplateObject(["", "/src"], ["", "/src"])), cwd));
            expect(util_1.standardizePath(templateObject_205 || (templateObject_205 = __makeTemplateObject(["", ""], ["", ""])), destPath)).to.equal(util_1.standardizePath(templateObject_206 || (templateObject_206 = __makeTemplateObject(["source/main.bs"], ["source/main.bs"]))));
        });
        it('excludes a file found outside the root dir', function () { return __awaiter(void 0, void 0, void 0, function () {
            var outDir, paths;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = rokuDeploy.getOptions(options);
                        outDir = path.resolve(options.outDir);
                        expect(rokuDeploy.getDestPath(util_1.standardizePath(templateObject_207 || (templateObject_207 = __makeTemplateObject(["", "/../source/main.brs"], ["", "/../source/main.brs"])), rootDir), [
                            '../source/**/*'
                        ], rootDir)).to.be.undefined;
                        return [4 /*yield*/, rokuDeploy.getFilePaths([{
                                    src: path.join('..', 'README.md'),
                                    dest: util_1.standardizePath(templateObject_208 || (templateObject_208 = __makeTemplateObject(["docs/README.md"], ["docs/README.md"])))
                                }], outDir)];
                    case 1:
                        paths = _a.sent();
                        expect(paths).to.eql([{
                                src: util_1.standardizePath(templateObject_209 || (templateObject_209 = __makeTemplateObject(["", "/README.md"], ["", "/README.md"])), cwd),
                                dest: util_1.standardizePath(templateObject_210 || (templateObject_210 = __makeTemplateObject(["docs/README.md"], ["docs/README.md"])))
                            }]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('normalizeRootDir', function () {
        it('handles falsey values', function () {
            expect(rokuDeploy.normalizeRootDir(null)).to.equal(cwd);
            expect(rokuDeploy.normalizeRootDir(undefined)).to.equal(cwd);
            expect(rokuDeploy.normalizeRootDir('')).to.equal(cwd);
            expect(rokuDeploy.normalizeRootDir(' ')).to.equal(cwd);
            expect(rokuDeploy.normalizeRootDir('\t')).to.equal(cwd);
        });
        it('handles non-falsey values', function () {
            expect(rokuDeploy.normalizeRootDir(cwd)).to.equal(cwd);
            expect(rokuDeploy.normalizeRootDir('./')).to.equal(cwd);
            expect(rokuDeploy.normalizeRootDir('./testProject')).to.equal(path.join(cwd, 'testProject'));
        });
    });
    describe('retrieveSignedPackage', function () {
        var onHandler;
        beforeEach(function () {
            sinon.stub(rokuDeploy.fsExtra, 'ensureDir').callsFake((function (pth, callback) {
                //do nothing, assume the dir gets created
            }));
            //fake out the write stream function
            sinon.stub(rokuDeploy.fsExtra, 'createWriteStream').returns(null);
            //intercept the http request
            sinon.stub(rokuDeploy.request, 'get').callsFake(function () {
                var request = {
                    on: function (event, callback) {
                        process.nextTick(function () {
                            onHandler(event, callback);
                        });
                        return request;
                    },
                    pipe: function () { }
                };
                return request;
            });
        });
        it('returns a pkg file path on success', function () { return __awaiter(void 0, void 0, void 0, function () {
            var pkgFilePath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        onHandler = function (event, callback) {
                            if (event === 'response') {
                                callback({
                                    statusCode: 200
                                });
                            }
                        };
                        return [4 /*yield*/, rokuDeploy.retrieveSignedPackage('path_to_pkg', {
                                outFile: 'roku-deploy-test'
                            })];
                    case 1:
                        pkgFilePath = _a.sent();
                        expect(pkgFilePath).to.equal(path.join(process.cwd(), 'out', 'roku-deploy-test.pkg'));
                        return [2 /*return*/];
                }
            });
        }); });
        it('throws when error in request is encountered', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_27;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        onHandler = function (event, callback) {
                            if (event === 'error') {
                                callback(new Error('Some error'));
                            }
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.retrieveSignedPackage('path_to_pkg', {
                                outFile: 'roku-deploy-test'
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_27 = _a.sent();
                        expect(e_27.message).to.equal('Some error');
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Should not have succeeded');
                        return [2 /*return*/];
                }
            });
        }); });
        it('throws when status code is non 200', function () { return __awaiter(void 0, void 0, void 0, function () {
            var e_28;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        onHandler = function (event, callback) {
                            if (event === 'response') {
                                callback({
                                    statusCode: 500
                                });
                            }
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.retrieveSignedPackage('path_to_pkg', {
                                outFile: 'roku-deploy-test'
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_28 = _a.sent();
                        expect(e_28.message.indexOf('Invalid response code')).to.equal(0);
                        return [2 /*return*/];
                    case 4:
                        assert.fail('Should not have succeeded');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('prepublishToStaging', function () {
        it('is resilient to file system errors', function () { return __awaiter(void 0, void 0, void 0, function () {
            var copy, count, stagingFolderPath, orig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        copy = rokuDeploy.fsExtra.copy;
                        count = 0;
                        //mock writeFile so we can throw a few errors during the test
                        sinon.stub(rokuDeploy.fsExtra, 'copy').callsFake(function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            count += 1;
                            //fail a few times
                            if (count < 5) {
                                throw new Error('fake error thrown as part of the unit test');
                            }
                            else {
                                return copy.apply(rokuDeploy.fsExtra, args);
                            }
                        });
                        stagingFolderPath = rokuDeploy.getOptions().stagingFolderPath;
                        orig = util_1.util.tryRepeatAsync.bind(util_1.util);
                        sinon.stub(util_1.util, 'tryRepeatAsync').callsFake(function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            return __awaiter(void 0, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    return [2 /*return*/, orig(args[0], args[1], 0)];
                                });
                            });
                        });
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging({
                                stagingFolderPath: stagingFolderPath,
                                files: [
                                    'source/main.brs'
                                ]
                            })];
                    case 1:
                        _a.sent();
                        expect(file(util_1.standardizePath(templateObject_211 || (templateObject_211 = __makeTemplateObject(["", "/source/main.brs"], ["", "/source/main.brs"])), stagingFolderPath))).to.exist;
                        expect(count).to.be.greaterThan(4);
                        return [2 /*return*/];
                }
            });
        }); });
        it('throws underlying error after the max fs error threshold is reached', function () { return __awaiter(void 0, void 0, void 0, function () {
            var copy, count, orig, stagingFolderPath, error, e_29;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        copy = rokuDeploy.fsExtra.copy;
                        count = 0;
                        //mock writeFile so we can throw a few errors during the test
                        sinon.stub(rokuDeploy.fsExtra, 'copy').callsFake(function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            count += 1;
                            //fail a few times
                            if (count < 15) {
                                throw new Error('fake error thrown as part of the unit test');
                            }
                            else {
                                return copy.apply(rokuDeploy.fsExtra, args);
                            }
                        });
                        orig = util_1.util.tryRepeatAsync.bind(util_1.util);
                        sinon.stub(util_1.util, 'tryRepeatAsync').callsFake(function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            return __awaiter(void 0, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    return [2 /*return*/, orig(args[0], args[1], 0)];
                                });
                            });
                        });
                        stagingFolderPath = rokuDeploy.getOptions().stagingFolderPath;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, rokuDeploy.prepublishToStaging({
                                stagingFolderPath: stagingFolderPath,
                                files: [
                                    'source/main.brs'
                                ]
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_29 = _a.sent();
                        error = e_29;
                        return [3 /*break*/, 4];
                    case 4:
                        expect(error, 'Should have thrown error').to.exist;
                        expect(error.message).to.equal('fake error thrown as part of the unit test');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('checkRequest', function () {
        it('throws FailedDeviceResponseError when necessary', function () {
            sinon.stub(rokuDeploy, 'getRokuMessagesFromResponseBody').returns({
                errors: ['a bad thing happened']
            });
            var ex;
            try {
                rokuDeploy['checkRequest']({
                    response: {},
                    body: 'something bad!'
                });
            }
            catch (e) {
                ex = e;
            }
            expect(ex).to.be.instanceof(errors.FailedDeviceResponseError);
        });
    });
    describe('getOptions', function () {
        it('calling with no parameters works', function () {
            sinon.stub(fsExtra, 'existsSync').callsFake(function (filePath) {
                return false;
            });
            var options = rokuDeploy.getOptions(undefined);
            expect(options.stagingFolderPath).to.exist;
        });
        it('calling with empty param object', function () {
            sinon.stub(fsExtra, 'existsSync').callsFake(function (filePath) {
                return false;
            });
            var options = rokuDeploy.getOptions({});
            expect(options.stagingFolderPath).to.exist;
        });
        it('works when passing in stagingFolderPath', function () {
            sinon.stub(fsExtra, 'existsSync').callsFake(function (filePath) {
                return false;
            });
            var options = rokuDeploy.getOptions({
                stagingFolderPath: './staging-dir'
            });
            expect(options.stagingFolderPath.endsWith('staging-dir')).to.be.true;
        });
        it('works when loading stagingFolderPath from rokudeploy.json', function () {
            sinon.stub(fsExtra, 'existsSync').callsFake(function (filePath) {
                return true;
            });
            sinon.stub(fsExtra, 'readFileSync').returns("\n                {\n                    \"stagingFolderPath\": \"./staging-dir\"\n                }\n            ");
            var options = rokuDeploy.getOptions();
            expect(options.stagingFolderPath.endsWith('staging-dir')).to.be.true;
        });
        it('supports jsonc for roku-deploy.json', function () {
            sinon.stub(fsExtra, 'existsSync').callsFake(function (filePath) {
                return filePath.endsWith('rokudeploy.json');
            });
            sinon.stub(fsExtra, 'readFileSync').returns("\n                //leading comment\n                {\n                    //inner comment\n                    \"rootDir\": \"src\" //trailing comment\n                }\n                //trailing comment\n            ");
            var options = rokuDeploy.getOptions(undefined);
            expect(options.rootDir).to.equal(path.join(process.cwd(), 'src'));
        });
        it('supports jsonc for bsconfig.json', function () {
            sinon.stub(fsExtra, 'existsSync').callsFake(function (filePath) {
                return filePath.endsWith('bsconfig.json');
            });
            sinon.stub(fsExtra, 'readFileSync').returns("\n                //leading comment\n                {\n                    //inner comment\n                    \"rootDir\": \"src\" //trailing comment\n                }\n                //trailing comment\n            ");
            var options = rokuDeploy.getOptions(undefined);
            expect(options.rootDir).to.equal(path.join(process.cwd(), 'src'));
        });
        it('catches invalid json with jsonc parser', function () {
            sinon.stub(fsExtra, 'existsSync').callsFake(function (filePath) {
                return filePath.endsWith('bsconfig.json');
            });
            sinon.stub(fsExtra, 'readFileSync').returns("\n                {\n                    \"rootDir\": \"src\"\n            ");
            var ex;
            try {
                var options_1 = rokuDeploy.getOptions(undefined);
            }
            catch (e) {
                ex = e;
            }
            expect(ex).to.exist;
            expect(ex.message.startsWith('Error parsing')).to.be.true;
        });
        it('does not error when no parameter provided', function () {
            expect(rokuDeploy.getOptions(undefined)).to.exist;
        });
        describe('packagePort', function () {
            it('defaults to 80', function () {
                expect(rokuDeploy.getOptions({}).packagePort).to.equal(80);
            });
            it('can be overridden', function () {
                expect(rokuDeploy.getOptions({ packagePort: 95 }).packagePort).to.equal(95);
            });
        });
        describe('remotePort', function () {
            it('defaults to 8060', function () {
                expect(rokuDeploy.getOptions({}).remotePort).to.equal(8060);
            });
            it('can be overridden', function () {
                expect(rokuDeploy.getOptions({ remotePort: 1234 }).remotePort).to.equal(1234);
            });
        });
        describe('config file', function () {
            var rokudeployPath = 'rokudeploy.json';
            var tempRokudeployPath = 'temp.rokudeploy.json';
            var bsconfigPath = 'bsconfig.json';
            beforeEach(function () {
                try {
                    fsExtra.renameSync(rokudeployPath, tempRokudeployPath);
                }
                catch (e) { }
            });
            afterEach(function () {
                try {
                    fsExtra.removeSync(rokudeployPath);
                    fsExtra.removeSync(bsconfigPath);
                    fsExtra.renameSync(tempRokudeployPath, rokudeployPath);
                }
                catch (e) { }
            });
            it('if no config file is available it should use the default values', function () {
                expect(rokuDeploy.getOptions({}).outFile).to.equal('roku-deploy');
            });
            it('if rokudeploy.json config file is available it should use those values instead of the default', function () {
                var expectedOutFile = 'expectedOutFile';
                fsExtra.writeJsonSync(rokudeployPath, {
                    outFile: expectedOutFile
                });
                expect(rokuDeploy.getOptions({}).outFile).to.equal(expectedOutFile);
            });
            it('if bsconfig.json config file is available it should use those values instead of the default', function () {
                var expectedOutFile = 'expectedOutFile';
                fsExtra.writeJsonSync(bsconfigPath, {
                    outFile: expectedOutFile
                });
                expect(rokuDeploy.getOptions({}).outFile).to.equal(expectedOutFile);
            });
            it('if rokudeploy.json config file is available and bsconfig.json is also available it should use rokudeploy.json instead of bsconfig.json', function () {
                fsExtra.writeJsonSync(bsconfigPath, {
                    outFile: 'bsconfigOutFile'
                });
                var expectedOutFile = 'rokudeployOutFile';
                fsExtra.writeJsonSync(rokudeployPath, {
                    outFile: expectedOutFile
                });
                expect(rokuDeploy.getOptions({}).outFile).to.equal(expectedOutFile);
            });
            it('if run time options are provided they should override any existing config file options', function () {
                fsExtra.writeJsonSync(bsconfigPath, {
                    outFile: 'bsconfigOutFile'
                });
                fsExtra.writeJsonSync(rokudeployPath, {
                    outFile: 'rokudeployOutFile'
                });
                var options = {
                    outFile: 'runTimeOutFile'
                };
                expect(rokuDeploy.getOptions(options).outFile).to.equal(options.outFile);
            });
            it('if run time config is provided it should override any existing config file options', function () {
                fsExtra.writeJsonSync(rokudeployPath, {
                    outFile: 'rokudeployOutFile'
                });
                fsExtra.writeJsonSync(bsconfigPath, {
                    outFile: 'bsconfigOutFile'
                });
                var projectPath = 'brsconfig.json';
                var expectedOutFile = 'projectConfigOutFile';
                fsExtra.writeJsonSync(projectPath, {
                    outFile: expectedOutFile
                });
                var options = {
                    project: projectPath
                };
                expect(rokuDeploy.getOptions(options).outFile).to.equal(expectedOutFile);
                fsExtra.removeSync(projectPath);
            });
        });
    });
    describe('deployAndSignPackage', function () {
        beforeEach(function () {
            //pretend the deploy worked
            sinon.stub(rokuDeploy, 'deploy').returns(Promise.resolve(null));
            //pretend the sign worked
            sinon.stub(rokuDeploy, 'signExistingPackage').returns(Promise.resolve(null));
            //pretend fetching the signed package worked
            sinon.stub(rokuDeploy, 'retrieveSignedPackage').returns(Promise.resolve('some_local_path'));
        });
        it('succeeds and does proper things with staging folder', function () { return __awaiter(void 0, void 0, void 0, function () {
            var stub, pkgFilePath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        stub = sinon.stub(rd.fsExtra, 'remove').returns(Promise.resolve());
                        return [4 /*yield*/, rokuDeploy.deployAndSignPackage({
                                retainStagingFolder: false
                            })];
                    case 1:
                        pkgFilePath = _a.sent();
                        //the return value should equal what retrieveSignedPackage returned.
                        expect(pkgFilePath).to.equal('some_local_path');
                        //fsExtra.remove should have been called
                        expect(stub.getCalls()).to.be.lengthOf(1);
                        //call it again, but specify true for retainStagingFolder
                        return [4 /*yield*/, rokuDeploy.deployAndSignPackage({
                                retainStagingFolder: true
                            })];
                    case 2:
                        //call it again, but specify true for retainStagingFolder
                        _a.sent();
                        //call count should NOT increase
                        expect(stub.getCalls()).to.be.lengthOf(1);
                        //call it again, but don't specify retainStagingFolder at all (it should default to FALSE)
                        return [4 /*yield*/, rokuDeploy.deployAndSignPackage({})];
                    case 3:
                        //call it again, but don't specify retainStagingFolder at all (it should default to FALSE)
                        _a.sent();
                        //call count should NOT increase
                        expect(stub.getCalls()).to.be.lengthOf(2);
                        return [2 /*return*/];
                }
            });
        }); });
        it('converts to squashfs if we request it to', function () { return __awaiter(void 0, void 0, void 0, function () {
            var stub;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options.convertToSquashfs = true;
                        stub = sinon.stub(rokuDeploy, 'convertToSquashfs').returns(Promise.resolve(null));
                        return [4 /*yield*/, rokuDeploy.deployAndSignPackage(options)];
                    case 1:
                        _a.sent();
                        expect(stub.getCalls()).to.be.lengthOf(1);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    function mockDoGetRequest(body, statusCode) {
        if (body === void 0) { body = ''; }
        if (statusCode === void 0) { statusCode = 200; }
        sinon.stub(rokuDeploy, 'doGetRequest').callsFake(function (params) {
            var results = { response: { statusCode: statusCode }, body: body };
            rokuDeploy.checkRequest(results);
            return Promise.resolve(results);
        });
    }
    function mockDoPostRequest(body, statusCode) {
        if (body === void 0) { body = ''; }
        if (statusCode === void 0) { statusCode = 200; }
        sinon.stub(rokuDeploy, 'doPostRequest').callsFake(function (params) {
            var results = { response: { statusCode: statusCode }, body: body };
            rokuDeploy.checkRequest(results);
            return Promise.resolve(results);
        });
    }
    function assertThrowsAsync(fn) {
        return __awaiter(this, void 0, void 0, function () {
            var f, e_30;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        f = function () { };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        return [4 /*yield*/, fn()];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3:
                        e_30 = _a.sent();
                        f = function () {
                            throw e_30;
                        };
                        return [3 /*break*/, 5];
                    case 4:
                        assert.throws(f);
                        return [7 /*endfinally*/];
                    case 5: return [2 /*return*/];
                }
            });
        });
    }
});
function expectThrowsAsync(callback, message) {
    if (message === void 0) { message = 'Expected to throw but did not'; }
    return __awaiter(this, void 0, void 0, function () {
        var wasExceptionThrown, e_31;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    wasExceptionThrown = false;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, callback()];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_31 = _a.sent();
                    wasExceptionThrown = true;
                    return [3 /*break*/, 4];
                case 4:
                    if (wasExceptionThrown === false) {
                        throw new Error(message);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function getFakeResponseBody(messages) {
    return "<html>\n        <head>\n        <meta charset=\"utf-8\">\n        <meta name=\"HandheldFriendly\" content=\"True\">\n        <title> Roku Development Kit </title>\n\n        <link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"css/global.css\" />\n        </head>\n        <body>\n        <div id=\"root\" style=\"background: #fff\">\n\n\n        </div>\n\n        <!-- Keep it, so old scripts can continue to work -->\n        <div style=\"display:none\">\n            <font color=\"red\">Failure: Form Error: \"archive\" Field Not Found\n        </font>\n            <font color=\"red\"></font>\n            <p><font face=\"Courier\">f1338f071efb2ff0f50824a00be3402a <br /> zip file in internal memory (3704254 bytes)</font></p>\n        </div>\n\n        <script type=\"text/javascript\" src=\"css/global.js\"></script>\n        <script type=\"text/javascript\">\n\n            // Include core components and resounce bundle (needed)\n            Shell.resource.set(null, {\n                endpoints: {}\n            });\n            Shell.create('Roku.Event.Key');\n            Shell.create('Roku.Events.Resize');\n            Shell.create('Roku.Events.Scroll');\n\n            // Create global navigation and render it\n            var nav = Shell.create('Roku.Nav')\n                .trigger('Enable standalone and utility mode - hide user menu, shopping cart, and etc.')\n                .trigger('Use compact footer')\n                .trigger('Hide footer')\n                .trigger('Render', document.getElementById('root'))\n                // Create custom links\n                .trigger('Remove all feature links from header')\n                .trigger('Add feature link in header', {\n                    text: 'Installer',\n                    url: 'plugin_install'\n                })\n                .trigger('Add feature link in header', {\n                    text: 'Utilities',\n                    url: 'plugin_inspect'\n                })\n\n                .trigger('Add feature link in header', { text: 'Packager', url: 'plugin_package' });\n\n            // Retrieve main content body node\n            var node = nav.invoke('Get main body section mounting node');\n\n            // Create page container and page header\n            var container = Shell.create('Roku.Nav.Page.Standard').trigger('Render', node);\n            node = container.invoke('Get main body node');\n            container.invoke('Get headline node').innerHTML = 'Development Application Installer';\n\n            node.innerHTML = '<p>Currently Installed Application:</p><p><font face=\"Courier\">f1338f071efb2ff0f50824a00be3402a <br /> zip file in internal memory (3704254 bytes)</font></p>';\n\n            // Set up form in main body content area\n            form = Shell.create('Roku.Form')\n                .trigger('Set form action URL', 'plugin_install')\n                .trigger('Set form encryption type to multi-part')\n                .trigger(\"Add file upload button\", {\n                    name: \"archive\",\n                    label: \"File:\"\n                })\n                .trigger(\"Add hidden input field\", {\n                    name: \"mysubmit\"\n            });\n\n            // Render some buttons\n            var Delete = document.createElement('BUTTON');\n            Delete.className = 'roku-button';\n            Delete.innerHTML = 'Delete';\n            Delete.onclick = function() {\n                form.trigger('Update input field value', { name: 'mysubmit', value: 'Delete'})\n                form.trigger('Force submit');\n            };\n            node.appendChild(Delete);\n\n            if (true)\n            {\n                // Render some buttons\n                var convert = document.createElement('BUTTON');\n                convert.className = 'roku-button';\n                convert.innerHTML = 'Convert to cramfs';\n                convert.onclick = function() {\n                    form.trigger('Update input field value', { name: 'mysubmit', value: 'Convert to cramfs'})\n                    form.trigger('Force submit');\n                };\n                node.appendChild(convert);\n\n                var convert2 = document.createElement('BUTTON');\n                convert2.className = 'roku-button';\n                convert2.innerHTML = 'Convert to squashfs';\n                convert2.onclick = function() {\n                    form.trigger('Update input field value', { name: 'mysubmit', value: 'Convert to squashfs'})\n                    form.trigger('Force submit');\n                };\n                node.appendChild(convert2);\n            }\n\n            var hrDiv = document.createElement('div');\n            hrDiv.innerHTML = '<hr />';\n            node.appendChild(hrDiv);\n\n            form.trigger('Render', node);\n\n            // Render some buttons\n            var submit = document.createElement('BUTTON');\n            submit.className = 'roku-button';\n            submit.innerHTML = 'Replace';\n            submit.onclick = function() {\n                form.trigger('Update input field value', { name: 'mysubmit', value: 'replace'})\n                if(form.invoke('Validate and get input values').valid === true) {\n                    form.trigger('Force submit');\n                }\n            };\n            node.appendChild(submit);\n\n            var d = document.createElement('div');\n            d.innerHTML = '<br />';\n            node.appendChild(d);\n\n            // Reder messages (info, error, and success)\n" + messages + "\n\n\n\n        </script>\n\n        </body>\n    </html>";
}
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16, templateObject_17, templateObject_18, templateObject_19, templateObject_20, templateObject_21, templateObject_22, templateObject_23, templateObject_24, templateObject_25, templateObject_26, templateObject_27, templateObject_28, templateObject_29, templateObject_30, templateObject_31, templateObject_32, templateObject_33, templateObject_34, templateObject_35, templateObject_36, templateObject_37, templateObject_38, templateObject_39, templateObject_40, templateObject_41, templateObject_42, templateObject_43, templateObject_44, templateObject_45, templateObject_46, templateObject_47, templateObject_48, templateObject_49, templateObject_50, templateObject_51, templateObject_52, templateObject_53, templateObject_54, templateObject_55, templateObject_56, templateObject_57, templateObject_58, templateObject_59, templateObject_60, templateObject_61, templateObject_62, templateObject_63, templateObject_64, templateObject_65, templateObject_66, templateObject_67, templateObject_68, templateObject_69, templateObject_70, templateObject_71, templateObject_72, templateObject_73, templateObject_74, templateObject_75, templateObject_76, templateObject_77, templateObject_78, templateObject_79, templateObject_80, templateObject_81, templateObject_82, templateObject_83, templateObject_84, templateObject_85, templateObject_86, templateObject_87, templateObject_88, templateObject_89, templateObject_90, templateObject_91, templateObject_92, templateObject_93, templateObject_94, templateObject_95, templateObject_96, templateObject_97, templateObject_98, templateObject_99, templateObject_100, templateObject_101, templateObject_102, templateObject_103, templateObject_104, templateObject_105, templateObject_106, templateObject_107, templateObject_108, templateObject_109, templateObject_110, templateObject_111, templateObject_112, templateObject_113, templateObject_114, templateObject_115, templateObject_116, templateObject_117, templateObject_118, templateObject_119, templateObject_120, templateObject_121, templateObject_122, templateObject_123, templateObject_124, templateObject_125, templateObject_126, templateObject_127, templateObject_128, templateObject_129, templateObject_130, templateObject_131, templateObject_132, templateObject_133, templateObject_134, templateObject_135, templateObject_136, templateObject_137, templateObject_138, templateObject_139, templateObject_140, templateObject_141, templateObject_142, templateObject_143, templateObject_144, templateObject_145, templateObject_146, templateObject_147, templateObject_148, templateObject_149, templateObject_150, templateObject_151, templateObject_152, templateObject_153, templateObject_154, templateObject_155, templateObject_156, templateObject_157, templateObject_158, templateObject_159, templateObject_160, templateObject_161, templateObject_162, templateObject_163, templateObject_164, templateObject_165, templateObject_166, templateObject_167, templateObject_168, templateObject_169, templateObject_170, templateObject_171, templateObject_172, templateObject_173, templateObject_174, templateObject_175, templateObject_176, templateObject_177, templateObject_178, templateObject_179, templateObject_180, templateObject_181, templateObject_182, templateObject_183, templateObject_184, templateObject_185, templateObject_186, templateObject_187, templateObject_188, templateObject_189, templateObject_190, templateObject_191, templateObject_192, templateObject_193, templateObject_194, templateObject_195, templateObject_196, templateObject_197, templateObject_198, templateObject_199, templateObject_200, templateObject_201, templateObject_202, templateObject_203, templateObject_204, templateObject_205, templateObject_206, templateObject_207, templateObject_208, templateObject_209, templateObject_210, templateObject_211;
//# sourceMappingURL=RokuDeploy.spec.js.map