"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("./util");
var chai_1 = require("chai");
describe('util', function () {
    describe('isFile', function () {
        it('recognizes valid files', function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = chai_1.expect;
                        return [4 /*yield*/, util_1.util.isFile(util_1.util.standardizePath(process.cwd() + "/README.md"))];
                    case 1:
                        _a.apply(void 0, [_b.sent()]).to.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        it('recognizes non-existant files', function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = chai_1.expect;
                        return [4 /*yield*/, util_1.util.isFile(util_1.util.standardizePath(process.cwd() + "/FILE_THAT_DOES_NOT_EXIST.md"))];
                    case 1:
                        _a.apply(void 0, [_b.sent()]).to.be.false;
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('toForwardSlashes', function () {
        it('returns original value for non-strings', function () {
            chai_1.expect(util_1.util.toForwardSlashes(undefined)).to.be.undefined;
            chai_1.expect(util_1.util.toForwardSlashes(false)).to.be.false;
        });
    });
    describe('isChildOfPath', function () {
        it('works for child path', function () {
            var parentPath = process.cwd() + "\\testProject";
            var childPath = process.cwd() + "\\testProject\\manifest";
            chai_1.expect(util_1.util.isParentOfPath(parentPath, childPath), "expected '" + childPath + "' to be child path of '" + parentPath + "'").to.be.true;
            //inverse is not true
            chai_1.expect(util_1.util.isParentOfPath(childPath, parentPath), "expected '" + parentPath + "' NOT to be child path of '" + childPath + "'").to.be.false;
        });
        it('handles mixed path separators', function () {
            var parentPath = process.cwd() + "\\testProject";
            var childPath = process.cwd() + "\\testProject/manifest";
            chai_1.expect(util_1.util.isParentOfPath(parentPath, childPath), "expected '" + childPath + "' to be child path of '" + parentPath + "'").to.be.true;
        });
        it('handles relative path traversals', function () {
            var parentPath = process.cwd() + "\\testProject";
            var childPath = process.cwd() + "/testProject/../testProject/manifest";
            chai_1.expect(util_1.util.isParentOfPath(parentPath, childPath), "expected '" + childPath + "' to be child path of '" + parentPath + "'").to.be.true;
        });
        it('works with trailing slashes', function () {
            var parentPath = process.cwd() + "/testProject/";
            var childPath = process.cwd() + "/testProject/../testProject/manifest";
            chai_1.expect(util_1.util.isParentOfPath(parentPath, childPath), "expected '" + childPath + "' to be child path of '" + parentPath + "'").to.be.true;
        });
        it('works with duplicate slashes', function () {
            var parentPath = process.cwd() + "///testProject/";
            var childPath = process.cwd() + "/testProject///testProject//manifest";
            chai_1.expect(util_1.util.isParentOfPath(parentPath, childPath), "expected '" + childPath + "' to be child path of '" + parentPath + "'").to.be.true;
        });
    });
    describe('stringReplaceInsensitive', function () {
        it('works for varying case', function () {
            chai_1.expect(util_1.util.stringReplaceInsensitive('aBcD', 'bCd', 'bcd')).to.equal('abcd');
        });
        it('returns the original string if the needle was not found in the haystack', function () {
            chai_1.expect(util_1.util.stringReplaceInsensitive('abcd', 'efgh', 'EFGH')).to.equal('abcd');
        });
    });
    describe('tryRepeatAsync', function () {
        it('calls callback', function () { return __awaiter(void 0, void 0, void 0, function () {
            var count;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        count = 0;
                        return [4 /*yield*/, util_1.util.tryRepeatAsync(function () {
                                count++;
                                if (count < 3) {
                                    throw new Error('test tryRepeatAsync');
                                }
                            }, 10, 0)];
                    case 1:
                        _a.sent();
                        chai_1.expect(count).to.equal(3);
                        return [2 /*return*/];
                }
            });
        }); });
        it('raises exception after max tries has been reached', function () { return __awaiter(void 0, void 0, void 0, function () {
            var error, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, util_1.util.tryRepeatAsync(function () {
                                throw new Error('test tryRepeatAsync');
                            }, 3, 1)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        error = e_1;
                        return [3 /*break*/, 3];
                    case 3:
                        chai_1.expect(error).to.exist;
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=util.spec.js.map